//## begin module.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module.cm

//## begin module.cp preserve=no
//## end module.cp

//## Module: Bank; Package body
//	Quellcodedatei
//## Subsystem: <Top Level>
//	Dateistruktur des Projektes mit Header- ud
//	Quellcodedateien
//	Erzeugte Dateien werden in MS-VC++ 6.0 Project
//	bernommen und dort ausprogrammiert
//	Der zustzlich  erzeugte Code bleibt auch nach
//	Hinzufgen von Komponenten im Modell erhalten!
//## Source file: c:\daten\uni\sofwaretechnik\stemabank\Bank.cpp


//## begin module.additionalIncludes preserve=no
//## end module.additionalIncludes

//## begin module.includes preserve=yes

#include "StdAfx.h"
#include "SteMaBank.h"
//## end module.includes

// Bank
#include "Bank.h"

//## begin module.declarations preserve=no
//## end module.declarations

//## begin module.additionalDeclarations preserve=yes
//## end module.additionalDeclarations


// Class Bank 









Bank::Bank()
  //## begin Bank::Bank%.hasinit preserve=no
      : cName("STEMA Bank"), reg_Kunde(NULL), cBLZ("081547110")
  //## end Bank::Bank%.hasinit
  //## begin Bank::Bank%.initialization preserve=yes
  //## end Bank::Bank%.initialization
{
  //## begin Bank::Bank%.body preserve=yes
	Kundenstamm = new CArray<Kunde*,Kunde*>;
	Sparbuecher=new CArray<Sparbuch*,Sparbuch*>;
	Festgelder=new CArray<Festgeld*,Festgeld*>;
	Girokonten=new CArray<Girokonto*,Girokonto*>;
	Auftraege=new CArray<Transaktion*,Transaktion*>;

	//ffnen der Archivdatei und Einlesen der Daten
	
	CFile f;
	if( !f.Open("bank.dat", CFile::modeRead ) ) 
	{
		#ifdef _DEBUG      
			afxDump << "Unable to open file" << "\n"; 
		#endif
		AfxMessageBox("Datenbestand nicht gefunden");
	}
	CArchive ar( &f, CArchive::load);
	Serialize(ar);

	ar.Close();
	f.Close();
	
    /*
	Kunde* Meier;
	Meier=new Kunde("Meier","Hans","21.04.1953","Viehweg 23,99453 Motzlar");
	new_Kunde(Meier);
	Kunde* Schulze;
	Schulze= new Kunde("Schulze","Reiner","04.10.1965","Mozartstr. 4,04473 Mnchhausen");
	new_Kunde(Schulze);
	Kunde* Beyer;
	Beyer= new Kunde("Beyer","Erwin","13.08.1971","Schillergasse 11,76534 Popendorf");
	new_Kunde(Beyer);
	*/
	
  //## end Bank::Bank%.body
}

Bank::Bank(const Bank &right)
  //## begin Bank::Bank%copy.hasinit preserve=no
      : cName("STEMA Bank"), reg_Kunde(NULL), cBLZ("081547110")
  //## end Bank::Bank%copy.hasinit
  //## begin Bank::Bank%copy.initialization preserve=yes
  //## end Bank::Bank%copy.initialization
{
  //## begin Bank::Bank%copy.body preserve=yes
  //## end Bank::Bank%copy.body
}


Bank::~Bank()
{
  //## begin Bank::~Bank%.body preserve=yes

	// Speichern des Datenbestandes in das Archiv

	CFile f;
	char buf[512];
	if( !f.Open( "bank.dat",CFile::modeCreate | CFile::modeWrite ) )
	{
	 #ifdef _DEBUG
	   afxDump << "Unable to open file" << "\n";
	 #endif
	 AfxMessageBox("Probleme beim ffnen der Datei bank.dat");
	}
	CArchive ar( &f, CArchive::store, 512, buf );
	Serialize(ar);

	ar.Close();
	f.Close();

	// Freigeben des Speichers
	for (int i = 0; i < Kundenstamm->GetSize(); i++)
	{
		delete Kundenstamm->GetAt(i);
	}
	for (i = 0; i < Sparbuecher->GetSize(); i++)
	{
		delete Sparbuecher->GetAt(i);
	}
	for (i = 0; i < Festgelder->GetSize(); i++)
	{
		delete Festgelder->GetAt(i);
	}
	for (i = 0; i < Girokonten->GetSize(); i++)
	{
		delete Girokonten->GetAt(i);
	}
	for (i = 0; i < Auftraege->GetSize(); i++)
	{
		delete Auftraege->GetAt(i);
	}
	
	delete Kundenstamm;
	delete Sparbuecher;
	delete Festgelder;
	delete Girokonten;
	delete Auftraege;
  //## end Bank::~Bank%.body
}



//## Other Operations (implementation)
BOOL Bank::new_Kunde(Kunde* pKunde)
{
  //## begin Bank::new_Kunde%931441218.body preserve=yes
	if (Kundenstamm->Add(pKunde) >= 0)
		return TRUE;
	else return FALSE;
  //## end Bank::new_Kunde%931441218.body
}

BOOL Bank::del_Kunde(const Kunde* pKunde)
{
  //## begin Bank::del_Kunde%936780708.body preserve=yes
	for (int i=0;i<Kundenstamm->GetSize();i++)
	{
		if ((Kundenstamm->GetAt(i) == pKunde)&&(pKunde->get_Einlagen ()->GetSize()==0) )
		{
			Kundenstamm->RemoveAt(i,1);
			return TRUE;
		}
	}
	return FALSE;
  //## end Bank::del_Kunde%936780708.body
}

Kunde* Bank::identify_Kunde(CString pcName, CString pcVorname, KundenID pcKundennummer)
{
  //## begin Bank::identify_Kunde%931441220.body preserve=yes

	Kunde* pKunde;
	for(int i = 0; i < Kundenstamm->GetSize(); i++)
	{
		pKunde = Kundenstamm->GetAt(i);
		if (((pKunde->get_Name() == pcName ) && (pKunde->get_Vorname() == pcVorname))
			||(pKunde->get_Kundennummer()==pcKundennummer)) return pKunde;
	} //end for

	return NULL;
	
  //## end Bank::identify_Kunde%931441220.body
}

BOOL Bank::Ueberweisung(float Betrag, EinlagenID Quelle, EinlagenID Ziel, CString Betreff)
{
  //## begin Bank::Ueberweisung%931715526.body preserve=yes
	return TRUE;
  //## end Bank::Ueberweisung%931715526.body
}

BOOL Bank::Einzahlung(float fBetrag, EinlagenID Ziel)
{
  //## begin Bank::Einzahlung%931715527.body preserve=yes
	return TRUE;
  //## end Bank::Einzahlung%931715527.body
}

BOOL Bank::Auszahlung(float ulBetrag, EinlagenID Quelle)
{
  //## begin Bank::Auszahlung%931715528.body preserve=yes
	return TRUE;
  //## end Bank::Auszahlung%931715528.body
}

BOOL Bank::new_Einlage(BYTE Typ, Kunde* pKunde, float Verzinsung, float min_Bestand, float min_Einzahlung, float Dispo, unsigned int Laufzeit)
{
  //## begin Bank::new_Einlage%936952072.body preserve=yes
	if (pKunde!=NULL) 
	{
	switch (Typ)
	{
	case SPARBUCH:
		Sparbuch* pSparbuch;
		pSparbuch=new Sparbuch;
		pSparbuch->set_Erstell_Dat(CTime::GetCurrentTime());
		pSparbuch->set_min_Bestand(min_Bestand);
		pSparbuch->set_min_Einzahlung(min_Einzahlung);
		pSparbuch->set_Verzinsung(Verzinsung);
		pSparbuch->set_InhaberID(pKunde->get_Kundennummer());
		pSparbuch->gen_EinlagenID(pKunde,Typ);
		pKunde->new_Einlage (pSparbuch->get_Einlagennummer());
		Sparbuecher->Add(pSparbuch);
		
		break;
	case GIROKONTO:
		Girokonto* pGirokonto;
		pGirokonto=new Girokonto;
		pGirokonto->set_Erstell_Dat(CTime::GetCurrentTime());
		pGirokonto->set_Verzinsung (Verzinsung);
		pGirokonto->set_Dispo (Dispo);
		pGirokonto->set_InhaberID(pKunde->get_Kundennummer());
		pGirokonto->gen_EinlagenID(pKunde,Typ);
		pKunde->new_Einlage (pGirokonto->get_Einlagennummer() );
		Girokonten->Add(pGirokonto);
		break;
	case FESTGELD:
		Festgeld* pFestgeld;
		pFestgeld=new Festgeld;
		pFestgeld->set_Erstell_Dat(CTime::GetCurrentTime());
		pFestgeld->set_Verzinsung (Verzinsung);
		pFestgeld->set_Laufzeit(Laufzeit); 
		pFestgeld->set_InhaberID(pKunde->get_Kundennummer());
		pFestgeld->gen_EinlagenID(pKunde,Typ);
		pKunde->new_Einlage (pFestgeld->get_Einlagennummer ());
		Festgelder->Add(pFestgeld);
		break;
	}; //end switch
	return TRUE;
	}
	else return FALSE;
  //## end Bank::new_Einlage%936952072.body
}

BYTE Bank::get_EinlagenTyp(EinlagenID Einlagennummer)
{
  //## begin Bank::get_EinlagenTyp%937385275.body preserve=yes
		TCHAR Typ;
	Typ=Einlagennummer.GetAt(4); 
	switch (Typ)
	{
	case '0':
		return SPARBUCH;
		break;
	case '4':
		return GIROKONTO;
		break;
	case '8':
		return FESTGELD;
		break;
	default:
		return 0;
		break;
	} //end switch
  //## end Bank::get_EinlagenTyp%937385275.body
}

Sparbuch* Bank::identify_Sparbuch(EinlagenID Sparbuchnummer)
{
  //## begin Bank::identify_Sparbuch%937385276.body preserve=yes
	for (int i=0;i<Sparbuecher->GetSize();i++)
	{
		if (Sparbuecher->GetAt(i)->get_Einlagennummer() == Sparbuchnummer )
			return Sparbuecher->GetAt(i);
	}
	return NULL;
  //## end Bank::identify_Sparbuch%937385276.body
}

Girokonto* Bank::identify_Girokonto(EinlagenID Kontonummer)
{
  //## begin Bank::identify_Girokonto%937385277.body preserve=yes
	for (int i=0;i<Girokonten->GetSize();i++)
	{
		if (Girokonten->GetAt(i)->get_Einlagennummer() == Kontonummer )
			return Girokonten->GetAt(i);
	}
	return NULL;	
  //## end Bank::identify_Girokonto%937385277.body
}

Festgeld* Bank::identify_Festgeld(EinlagenID Festgeldnummer)
{
  //## begin Bank::identify_Festgeld%937385278.body preserve=yes
	for (int i=0;i<Festgelder->GetSize();i++)
	{
		if (Festgelder->GetAt(i)->get_Einlagennummer() == Festgeldnummer )
			return Festgelder->GetAt(i);
	}
	return NULL;
  //## end Bank::identify_Festgeld%937385278.body
}

BOOL Bank::new_Transaktion(Transaktion* pTransakt)
{
  //## begin Bank::new_Transaktion%937432490.body preserve=yes
	if (Auftraege->Add(pTransakt) >= 0)
		return TRUE;
	else return FALSE;
  //## end Bank::new_Transaktion%937432490.body
}

BOOL Bank::del_Einlage(EinlagenID Einlage)
{
  //## begin Bank::del_Einlage%937583337.body preserve=yes
	BYTE Typ;
	Typ=get_EinlagenTyp(Einlage);
	switch (Typ)
	{
	case SPARBUCH:
		{
			Sparbuch* pSparbuch;
				for (int i=0;i<Sparbuecher->GetSize();i++)
				{
					pSparbuch=Sparbuecher->GetAt(i);
					if ((pSparbuch->get_Einlagennummer ()=Einlage)&&(pSparbuch->get_Bestand()==0 ))
					{
						identify_Inhaber(Einlage)->del_Einlage(Einlage);
						Sparbuecher->RemoveAt(i,1);
						return TRUE;
						break;
					}		
				}
				return FALSE;
				break;
		}
	case FESTGELD:
		{
			Festgeld* pFestgeld;
				for (int i=0;i<Festgelder->GetSize();i++)
				{
					pFestgeld=Festgelder->GetAt(i);
					if ((pFestgeld->get_Einlagennummer ()=Einlage)&&(pFestgeld->get_Bestand()==0))
					{
						identify_Inhaber(Einlage)->del_Einlage(Einlage);
						Festgelder->RemoveAt(i,1);
						return TRUE;
						break;
					}		
				}
				return FALSE;
				break;
		}
	case GIROKONTO:
		{
			Girokonto* pGirokonto;
				for (int i=0;i<Girokonten->GetSize();i++)
				{
					pGirokonto=Girokonten->GetAt(i);
					if ((pGirokonto->get_Einlagennummer ()=Einlage)&&(pGirokonto->get_Bestand()==0))
					{
						identify_Inhaber(Einlage)->del_Einlage(Einlage);
						Girokonten->RemoveAt(i,1);
						return TRUE;
						break;
					}		
				}
				return FALSE;
				break;
		}
	default:
		{
			return FALSE;
			break;
		}

	} //end switch
	return FALSE;
  //## end Bank::del_Einlage%937583337.body
}

Kunde* Bank::get_Kunde_fromID(KundenID Kundennummer)
{
  //## begin Bank::get_Kunde_fromID%937866641.body preserve=yes
	Kunde* pKunde;
	for(int i = 0; i<Kundenstamm->GetSize(); i++)
	{
		pKunde = Kundenstamm->GetAt(i);
		if (pKunde->get_Kundennummer()==Kundennummer) 
			return pKunde;
	} //end for

	return NULL;
  //## end Bank::get_Kunde_fromID%937866641.body
}

void Bank::Serialize(CArchive& ar)
{
  //## begin Bank::Serialize%937906214.body preserve=yes

	if (ar.IsStoring()) //Abspeichern der Daten in das Archiv
	{
		ar << Kundenstamm->GetSize();   
		for (int i=0; i < Kundenstamm->GetSize(); i++)
		{   
			ar << Kundenstamm->GetAt(i);
		}
		/////////////////////////////////////////////////
		ar << Girokonten->GetSize();   
		for (i=0; i < Girokonten->GetSize(); i++)
		{   
			ar << Girokonten->GetAt(i);
		}
		/////////////////////////////////////////////////
		ar << Sparbuecher->GetSize();   
		for (i=0; i < Sparbuecher->GetSize(); i++)
		{   
			ar << Sparbuecher->GetAt(i);
		}
		/////////////////////////////////////////////////
		ar << Festgelder->GetSize();   
		for (i=0; i < Festgelder->GetSize(); i++)
		{   
			ar << Festgelder->GetAt(i);
		}
		/////////////////////////////////////////////////
		ar << Auftraege->GetSize();   
		for (i=0; i < Auftraege->GetSize(); i++)
		{   
			ar << Auftraege->GetAt(i);
		}
	}
	else		//Einlesen der Daten aus dem Archiv
	{
		int size;
		Kunde* pKunde;
		Girokonto* pGirokonto;
		Sparbuch* pSparbuch;
		Festgeld* pFestgeld;
		Transaktion* pTransaktion;
		
		ar >> size;
		for (int i=0; i < size; i++)
		{
			ar >> pKunde;
			Kundenstamm->Add(pKunde);
		}
		////////////////////////////////////////////////
		ar >> size;
		for (i=0; i < size; i++)
		{
			ar >> pGirokonto;
			Girokonten->Add(pGirokonto);
		}
		////////////////////////////////////////////////
		ar >> size;
		for (i=0; i < size; i++)
		{
			ar >> pSparbuch;
			Sparbuecher->Add(pSparbuch);
		}
		////////////////////////////////////////////////
		ar >> size;
		for (i=0; i < size; i++)
		{
			ar >> pFestgeld;
			Festgelder->Add(pFestgeld);
		}
		////////////////////////////////////////////////
		ar >> size;
		for (i=0; i < size; i++)
		{
			ar >> pTransaktion;
			Auftraege->Add(pTransaktion);
		}

	}

  //## end Bank::Serialize%937906214.body
}

Kunde* Bank::identify_Inhaber(EinlagenID Einlagennummer)
{
  //## begin Bank::identify_Inhaber%937926124.body preserve=yes
	CString Kundennummer = Einlagennummer.Left(4);
	return get_Kunde_fromID(Kundennummer);

  //## end Bank::identify_Inhaber%937926124.body
}


// Additional Declarations
//## begin Bank.declarations preserve=yes
//## end Bank.declarations




