//## begin module.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module.cm

//## begin module.cp preserve=no
//## end module.cp

//## Module: Bank; Package specification
//	Headerfile
//## Subsystem: <Top Level>
//	Dateistruktur des Projektes mit Header- ud
//	Quellcodedateien
//	Erzeugte Dateien werden in MS-VC++ 6.0 Project
//	bernommen und dort ausprogrammiert
//	Der zustzlich  erzeugte Code bleibt auch nach
//	Hinzufgen von Komponenten im Modell erhalten!
//## Source file: c:\daten\uni\sofwaretechnik\stemabank\Bank.h


#ifndef Bank_h
#define Bank_h 1

//## begin module.additionalIncludes preserve=no
//## end module.additionalIncludes

//## begin module.includes preserve=yes
//## end module.includes

// Transaktion
#include "Trnskton.h"
// Kunde
#include "Kunde.h"
// Festgeld
#include "Festgeld.h"
// Sparbuch
#include "Sparbuch.h"
// Girokonto
#include "Girkonto.h"
// globals
#include "globals.h"

//## begin module.declarations preserve=no
//## end module.declarations

//## begin module.additionalDeclarations preserve=yes
//## end module.additionalDeclarations


//## Class: Bank
//	Fat die Kunden und deren Geldeinalgen zusammen.
//	Funktionalitten:
//	- Speicherung aller Einlagen, Kunden und Transaktionen
//	-Erstellen, Suchen, Lschen der Kunden, Einlagen,
//	Transaktionen
//	-Behandlung eines angemeldeten Kunden
//## Category: Kunden und Einlagenverwaltung
//## Subsystem: <Top Level>
//## Persistence: Transient
//## Cardinality/Multiplicity: n

//## Uses: <unnamed>; KundenID { -> }
//## Uses: <unnamed>; EinlagenID { -> }

class Bank 
{
  //## begin Bank.initialDeclarations preserve=yes
  //## end Bank.initialDeclarations

  public:
    //## Constructors (generated)
      Bank();

      Bank(const Bank &right);

    //## Destructor (generated)
      ~Bank();


    //## Other Operations (specified)
      //## Operation: new_Kunde%931441218
      //	speichert den bergebenen Zeiger auf den Kunden im
      //	Kundenstamm und liefert Efolgsmeldung zurck
      //	(TRUE,FALSE)
      BOOL new_Kunde(Kunde* pKunde);

      //## Operation: del_Kunde%936780708
      //	lscht den bergebenen Zeiger auf den Kunden im
      //	Kundenstamm und liefert Efolgsmeldung zurck
      //	(TRUE,FALSE)
      BOOL del_Kunde(const Kunde* pKunde);

      //## Operation: identify_Kunde%931441220
      //	prft, ob der Kunde ( Name, Vorname, KundenID ) in der
      //	Kundenverwaltung angemeldet ist und liefert dessen
      //	Adresse zurck
      Kunde* identify_Kunde(CString pcName, CString pcVorname, KundenID pcKundennummer);

      //## Operation: Ueberweisung%931715526
      //	Methode, die eine berweisung generiert und durchfhrt
      BOOL Ueberweisung(float Betrag, EinlagenID Quelle, EinlagenID Ziel, CString Betreff);

      //## Operation: Einzahlung%931715527
      //	Methode, die eine Einzahlung generiert und durchfhrt
      BOOL Einzahlung(float fBetrag, EinlagenID Ziel);

      //## Operation: Auszahlung%931715528
      //	Methode, die eine Auszahlung generiert und durchfhrt
      BOOL Auszahlung(float ulBetrag, EinlagenID Quelle);

      //## Operation: new_Einlage%936952072
      //	Erzeugt je nach bergebenen Typ eine Einlage (Girokonto,
      //	Festgeld, Sparbuch) und weist den Membervariablen je
      //	nach Typ  bergebene Parameter zu.
      //	Anschlieend werden die Zeiger auf die Einlagen in den
      //	Einlagenarrays gespeichert!
      BOOL new_Einlage(BYTE Typ, Kunde* pKunde, float Verzinsung = 0, float min_Bestand = 0, float min_Einzahlung = 0, float Dispo = 0, unsigned int Laufzeit = 1);

      //## Operation: get_EinlagenTyp%937385275
      //	liefert den Einlagentyp einer Einlage durch
      //	vordefinierten BYTE-Wert zurck!
      BYTE get_EinlagenTyp(EinlagenID Einlagennummer);

      //## Operation: identify_Sparbuch%937385276
      //	sucht mit bergebener Einlagennummer im CArray
      //	Sparbuecher nach der dazugehrigen Einlage und liefert
      //	dessen Zeiger zurck!
      Sparbuch* identify_Sparbuch(EinlagenID Sparbuchnummer);

      //## Operation: identify_Girokonto%937385277
      //	sucht mit bergebener Einlagennummer im CArray
      //	Girokonten nach der dazugehrigen Einlage und liefert
      //	dessen Zeiger zurck
      Girokonto* identify_Girokonto(EinlagenID Kontonummer);

      //## Operation: identify_Festgeld%937385278
      //	sucht mit bergebener Einlagennummer im CArray
      //	Festgelder nach der dazugehrigen Einlage und liefert
      //	dessen Zeiger zurck
      Festgeld* identify_Festgeld(EinlagenID Festgeldnummer);

      //## Operation: new_Transaktion%937432490
      //	Speichert bergebenen Zeiger auf eine Transaktion im
      //	CArray Auftrge und liefert Erfolgsmeldung zurck.
      BOOL new_Transaktion(Transaktion* pTransakt);

      //## Operation: del_Einlage%937583337
      //	Sucht mit bergebener Einlagennummer nach entsprechender
      //	Einlage im CArray ... und lscht diese.
      //	Desweiteren wird die entsprechende Funktion beim Kunde
      //	aufgerufen!
      BOOL del_Einlage(EinlagenID Einlage = "");

      //## Operation: get_Kunde_fromID%937866641
      //	liefert einen Zeiger auf den Kunden zurck, der die der
      //	Funktion bergebene KundenID besitzt
      Kunde* get_Kunde_fromID(KundenID Kundennummer);

      //## Operation: Serialize%937906214
      //	jede Datenklasse besitzt ihr eigene
      //	Serialisierungsfunktion.
      //	sie dient zur permanenten Speicherung des gesammten
      //	Datenbestandes der Bank.
      //	jede Klasse serialisiert sich praktisch selbst, indem
      //	sie ihre Daten serialisiert.
      void Serialize(CArchive& ar);

      //## Operation: identify_Inhaber%937926124
      //	liefert den Kunden zurck, dem die der Funktion
      //	bergebene EinlagenID gehrt
      Kunde* identify_Inhaber(EinlagenID Einlagennummer);

    //## Get and Set Operations for Has Relationships (generated)

      //## Documentation Bank::Sparbuecher.has
      //	Speicherung der Zeiger auf die Bcher in CArray
      //	Sparbuecher bei der Bank
      const CArray<Sparbuch*,Sparbuch*>* get_Sparbuecher() const;

      //## Documentation Bank::Festgelder.has
      //	Speicherung der Zeiger auf die Festgelder in CArray
      //	Festgelder bei der Bank
      CArray<Festgeld*,Festgeld*>* get_Festgelder();

      //## Documentation Bank::Girokonten.has
      //	Speicherung der Zeiger auf die Konten in CArray
      //	Girokonten bei der Bank
      const CArray<Girokonto*,Girokonto*>* get_Girokonten() const;

    //## Get and Set Operations for Class Attributes (generated)

      //## Attribute: reg_Kunde
      //	Zeiger auf aktuell angemeldeten Kunde
      Kunde* get_reg_Kunde();
      void set_reg_Kunde(Kunde*const  value);

    //## Get and Set Operations for Associations (generated)

      //## Association: durchfuehren%37C29D12012C
      //## Role: Bank::Auftraege
      CArray<Transaktion*,Transaktion*>* get_Auftraege();

      //## Association: Bank_Kunde_Rel%3770AB8801E0
      //## Role: Bank::Kundenstamm
      const CArray<Kunde*,Kunde*>* get_Kundenstamm() const;

    // Additional Public Declarations
      //## begin Bank.public preserve=yes
      //## end Bank.public


  protected:
    // Additional Protected Declarations
      //## begin Bank.protected preserve=yes
      //## end Bank.protected


  private:
    //## Get and Set Operations for Class Attributes (generated)

      //## Attribute: cName
      //	Membervariable
      //	Name der Bank voreingestellt!
      const CString get_cName() const;
      void set_cName(const CString value);

      //## Attribute: cBLZ
      //	Membervariable
      //	voreingestellte Bankleitzahl
      const CString get_cBLZ() const;
      void set_cBLZ(const CString value);

    // Additional Private Declarations
      //## begin Bank.private preserve=yes
      //## end Bank.private


  private:  //## implementation
    // Data Members for Has Relationships

      //## begin Bank::Sparbuecher.has preserve=no  public: Sparbuch {1..1 -> nRO}
      CArray<Sparbuch*,Sparbuch*>* Sparbuecher;
      //## end Bank::Sparbuecher.has

      //## begin Bank::Festgelder.has preserve=no  public: Festgeld {1..1 -> nRO}
      CArray<Festgeld*,Festgeld*>* Festgelder;
      //## end Bank::Festgelder.has

      //## begin Bank::Girokonten.has preserve=no  public: Girokonto {1..1 -> nRO}
      CArray<Girokonto*,Girokonto*>* Girokonten;
      //## end Bank::Girokonten.has

    // Data Members for Class Attributes

      //## begin Bank::cName.attr preserve=no  private: CString {U} "STEMA Bank"
      CString cName;
      //## end Bank::cName.attr

      //## begin Bank::reg_Kunde.attr preserve=no  public: Kunde* {U} NULL
      Kunde* reg_Kunde;
      //## end Bank::reg_Kunde.attr

      //## begin Bank::cBLZ.attr preserve=no  private: CString {U} "081547110"
      CString cBLZ;
      //## end Bank::cBLZ.attr

    // Data Members for Associations

      //## Association: durchfuehren%37C29D12012C
      //## begin Bank::Auftraege.role preserve=no  public: Transaktion {1..1 -> 0..nRHN}
      CArray<Transaktion*,Transaktion*>* Auftraege;
      //## end Bank::Auftraege.role

      //## Association: Bank_Kunde_Rel%3770AB8801E0
      //## begin Bank::Kundenstamm.role preserve=no  public: Kunde {1..1 -> 0..nRHN}
      CArray<Kunde*,Kunde*>* Kundenstamm;
      //## end Bank::Kundenstamm.role

    // Additional Implementation Declarations
      //## begin Bank.implementation preserve=yes
      //## end Bank.implementation

};



// Class Bank 

//## Get and Set Operations for Has Relationships (inline)

inline const CArray<Sparbuch*,Sparbuch*>* Bank::get_Sparbuecher() const
{
  //## begin Bank::get_Sparbuecher%.get preserve=no
  return Sparbuecher;
  //## end Bank::get_Sparbuecher%.get
}

inline CArray<Festgeld*,Festgeld*>* Bank::get_Festgelder()
{
  //## begin Bank::get_Festgelder%.get preserve=no
  return Festgelder;
  //## end Bank::get_Festgelder%.get
}

inline const CArray<Girokonto*,Girokonto*>* Bank::get_Girokonten() const
{
  //## begin Bank::get_Girokonten%.get preserve=no
  return Girokonten;
  //## end Bank::get_Girokonten%.get
}

//## Get and Set Operations for Class Attributes (inline)

inline const CString Bank::get_cName() const
{
  //## begin Bank::get_cName%.get preserve=no
  return cName;
  //## end Bank::get_cName%.get
}

inline void Bank::set_cName(const CString value)
{
  //## begin Bank::set_cName%.set preserve=no
  cName = value;
  //## end Bank::set_cName%.set
}

inline Kunde* Bank::get_reg_Kunde()
{
  //## begin Bank::get_reg_Kunde%.get preserve=no
  return reg_Kunde;
  //## end Bank::get_reg_Kunde%.get
}

inline void Bank::set_reg_Kunde(Kunde*const  value)
{
  //## begin Bank::set_reg_Kunde%.set preserve=no
  reg_Kunde = value;
  //## end Bank::set_reg_Kunde%.set
}

inline const CString Bank::get_cBLZ() const
{
  //## begin Bank::get_cBLZ%.get preserve=no
  return cBLZ;
  //## end Bank::get_cBLZ%.get
}

inline void Bank::set_cBLZ(const CString value)
{
  //## begin Bank::set_cBLZ%.set preserve=no
  cBLZ = value;
  //## end Bank::set_cBLZ%.set
}

//## Get and Set Operations for Associations (inline)

inline CArray<Transaktion*,Transaktion*>* Bank::get_Auftraege()
{
  //## begin Bank::get_Auftraege%.get preserve=no
  return Auftraege;
  //## end Bank::get_Auftraege%.get
}

inline const CArray<Kunde*,Kunde*>* Bank::get_Kundenstamm() const
{
  //## begin Bank::get_Kundenstamm%.get preserve=no
  return Kundenstamm;
  //## end Bank::get_Kundenstamm%.get
}





#endif


