// DialogAktKunde.cpp: Implementierungsdatei
//

#include "stdafx.h"
#include "SteMaBank.h"
#include "DialogAktKunde.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// Dialogfeld CDialogAktKunde 


CDialogAktKunde::CDialogAktKunde(CWnd* pParent /*=NULL*/)
	: CDialog(CDialogAktKunde::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDialogAktKunde)
	m_anschrift = _T("");
	m_gebdat = _T("");
	m_kundenid = _T("");
	m_name = _T("");
	m_vorname = _T("");
	//}}AFX_DATA_INIT
}


void CDialogAktKunde::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDialogAktKunde)
	DDX_Control(pDX, IDC_LIST_EINLAGEN, m_einlagenliste);
	DDX_Text(pDX, IDC_EDIT_ANSCHRIFT, m_anschrift);
	DDX_Text(pDX, IDC_EDIT_GEBDAT, m_gebdat);
	DDX_Text(pDX, IDC_EDIT_KUNDENID, m_kundenid);
	DDX_Text(pDX, IDC_EDIT_NAME, m_name);
	DDX_Text(pDX, IDC_EDIT_VORNAME, m_vorname);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDialogAktKunde, CDialog)
	//{{AFX_MSG_MAP(CDialogAktKunde)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Behandlungsroutinen fr Nachrichten CDialogAktKunde 

void CDialogAktKunde::PostNcDestroy() 
{
	delete this;
}

void CDialogAktKunde::aktualisiereDaten()
{
	m_anschrift = theApp.GetSteMaBank()->get_reg_Kunde()->get_Anschrift();
	m_gebdat = theApp.GetSteMaBank()->get_reg_Kunde()->get_Geb_Dat();
	m_kundenid = theApp.GetSteMaBank()->get_reg_Kunde()->get_Kundennummer();
	m_name = theApp.GetSteMaBank()->get_reg_Kunde()->get_Name();
	m_vorname = theApp.GetSteMaBank()->get_reg_Kunde()->get_Vorname();


	
	m_einlagenliste.DeleteAllItems();
	EinlagenID einlagennummer;
	
	for(int i = 0; i < theApp.GetSteMaBank()->get_reg_Kunde()->get_Einlagen()->GetSize(); i++)
	{
		einlagennummer = theApp.GetSteMaBank()->get_reg_Kunde()->get_Einlagen()->GetAt(i);
		/////////////////////////////////////////////////////////////////////////////////////
		Girokonto* pGiro = NULL;
		if ( theApp.GetSteMaBank()->get_EinlagenTyp(einlagennummer) == GIROKONTO )
		{
			pGiro = theApp.GetSteMaBank()->identify_Girokonto(einlagennummer);

			if (pGiro != NULL)
			{
				m_einlagenliste.InsertItem(i, pGiro->get_Einlagennummer());
				m_einlagenliste.SetItem(i, 1, LVIF_TEXT, "Girokonto", 0, 0, 0, 0);
		
				float bestand = pGiro->get_Bestand();
				CString str;
				str.Format("%0.2f",bestand);
				m_einlagenliste.SetItem(i, 2, LVIF_TEXT, str, 0, 0, 0, 0);
			
				if (pGiro->get_Status())
					m_einlagenliste.SetItem(i, 3, LVIF_TEXT, "OK", 0, 0, 0, 0);
				else
					m_einlagenliste.SetItem(i, 3, LVIF_TEXT, "GESPERRT", 0, 0, 0, 0);

			}
		}
		/////////////////////////////////////////////////////////////////////////////////////
		Sparbuch* pSparbuch = NULL;
		if ( theApp.GetSteMaBank()->get_EinlagenTyp(einlagennummer) == SPARBUCH )
		{
			pSparbuch = theApp.GetSteMaBank()->identify_Sparbuch(einlagennummer);

			if (pSparbuch != NULL)
			{
				m_einlagenliste.InsertItem(i, pSparbuch->get_Einlagennummer());
				m_einlagenliste.SetItem(i, 1, LVIF_TEXT, "Sparbuch", 0, 0, 0, 0);
		
				float bestand = pSparbuch->get_Bestand();
				CString str;
				str.Format("%0.2f",bestand);
				m_einlagenliste.SetItem(i, 2, LVIF_TEXT, str, 0, 0, 0, 0);
			
				if (pSparbuch->get_Status())
					m_einlagenliste.SetItem(i, 3, LVIF_TEXT, "OK", 0, 0, 0, 0);
				else
					m_einlagenliste.SetItem(i, 3, LVIF_TEXT, "GESPERRT", 0, 0, 0, 0);

			}
		}
		/////////////////////////////////////////////////////////////////////////////////////
		Festgeld* pFestgeld = NULL;
		if ( theApp.GetSteMaBank()->get_EinlagenTyp(einlagennummer) == FESTGELD )
		{
			pFestgeld = theApp.GetSteMaBank()->identify_Festgeld(einlagennummer);

			if (pFestgeld != NULL)
			{
				m_einlagenliste.InsertItem(i, pFestgeld->get_Einlagennummer());
				m_einlagenliste.SetItem(i, 1, LVIF_TEXT, "Festgeld", 0, 0, 0, 0);
		
				float bestand = pFestgeld->get_Bestand();
				CString str;
				str.Format("%0.2f",bestand);
				m_einlagenliste.SetItem(i, 2, LVIF_TEXT, str, 0, 0, 0, 0);
			
				if (pFestgeld->get_Status())
					m_einlagenliste.SetItem(i, 3, LVIF_TEXT, "OK", 0, 0, 0, 0);
				else
					m_einlagenliste.SetItem(i, 3, LVIF_TEXT, "GESPERRT", 0, 0, 0, 0);

			}
		}
		
	}

	UpdateData(FALSE);
}

BOOL CDialogAktKunde::OnInitDialog() 
{
	CDialog::OnInitDialog();

	m_einlagenliste.InsertColumn(0, "Einl.ID", LVCFMT_LEFT, 60,0);
	m_einlagenliste.InsertColumn(1, "Art", LVCFMT_LEFT, 90,0);
	m_einlagenliste.InsertColumn(2, "Bestand", LVCFMT_LEFT, 60,1);
	m_einlagenliste.InsertColumn(3, "Status", LVCFMT_LEFT, 60,1);
	
	aktualisiereDaten();
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX-Eigenschaftenseiten sollten FALSE zurckgeben
}


void CDialogAktKunde::CloseWindow()
{
	CDialog::OnCancel();
}
