// DialogAuszahlung.cpp: Implementierungsdatei
//

#include "stdafx.h"
#include "SteMaBank.h"
#include "DialogAuszahlung.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// Dialogfeld CDialogAuszahlung 


CDialogAuszahlung::CDialogAuszahlung(CWnd* pParent /*=NULL*/)
	: CDialog(CDialogAuszahlung::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDialogAuszahlung)
	m_betrag = 0.0f;
	m_quellenummer = _T("");
	m_quelletyp = _T("");
	m_verwzweck = _T("");
	m_quellebestand = 0.0f;
	//}}AFX_DATA_INIT
}


void CDialogAuszahlung::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDialogAuszahlung)
	DDX_Control(pDX, IDOK, m_buttonok);
	DDX_Control(pDX, IDC_BUTTON_UEBERPRUEFEN, m_ueberpruefen);
	DDX_Text(pDX, IDC_EDIT_BETRAG, m_betrag);
	DDV_MinMaxFloat(pDX, m_betrag, 1.e-002f, 1.e+007f);
	DDX_Text(pDX, IDC_EDIT_QUELLE_NR, m_quellenummer);
	DDV_MaxChars(pDX, m_quellenummer, 8);
	DDX_Text(pDX, IDC_EDIT_QUELLE_TYP, m_quelletyp);
	DDX_Text(pDX, IDC_EDIT_VERZWECK, m_verwzweck);
	DDX_Text(pDX, IDC_EDIT_QUELLEBESTAND, m_quellebestand);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDialogAuszahlung, CDialog)
	//{{AFX_MSG_MAP(CDialogAuszahlung)
	ON_BN_CLICKED(IDC_BUTTON_UEBERPRUEFEN, OnButtonUeberpruefen)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Behandlungsroutinen fr Nachrichten CDialogAuszahlung 

BOOL CDialogAuszahlung::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	m_buttonok.EnableWindow(FALSE);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX-Eigenschaftenseiten sollten FALSE zurckgeben
}

void CDialogAuszahlung::OnOK() 
{
	if (Check())
	{
		Transaktion* pTransaktion = new Transaktion;
		pTransaktion->set_Typ(AUSZAHLUNG);
		pTransaktion->set_Status(CHECKED);
		pTransaktion->set_Betrag(m_betrag);
		pTransaktion->set_Betreff(m_verwzweck);
		pTransaktion->set_QuelleZiel(0, m_quellenummer);
		pTransaktion->set_QuelleZiel(1, "");

		if (pTransaktion->executeAll())
		{
			//Einfgen in den Datenbestand der Bank
			theApp.GetSteMaBank()->new_Transaktion(pTransaktion);
			//Einfgen in die Transaktonsliste des Auftraggebers
			theApp.GetSteMaBank()->get_reg_Kunde()->new_Transaktion(pTransaktion->get_Transaktionsnummer());
			AfxMessageBox("Transaktion erfolgreich ausgefhrt!");
		}
		else
		{
			delete pTransaktion;
			AfxMessageBox("Transaktion fehlgeschlagen!");
		}
	
		CDialog::OnOK();
	}
		
}

void CDialogAuszahlung::OnButtonUeberpruefen() 
{
	if (Check())
	{
		m_buttonok.EnableWindow(TRUE);
	}
	
	UpdateData(FALSE);
}

BOOL CDialogAuszahlung::Check()
{
	UpdateData(TRUE);

	if ((m_verwzweck != "") && (m_quellenummer !=""))
	{
		BYTE Typ = 0;
		if (m_quellenummer.GetLength()>=5 )
			Typ = theApp.GetSteMaBank()->get_EinlagenTyp(m_quellenummer);
		else 
		{
			AfxMessageBox("unvollstndige EinlagenID!");
			return FALSE;
		}
		switch (Typ)
		{
			case GIROKONTO : 
			{
				Girokonto* pGiro = theApp.GetSteMaBank()->identify_Girokonto(m_quellenummer);
				if (!pGiro)
				{
					AfxMessageBox("Quell-Girokonto nicht gefunden");
					return FALSE;
				}
				else 
				{
					m_quellebestand = pGiro->get_Bestand();
					m_quelletyp = "Girokonto";
					return TRUE;
				}
				break;
			}
			case FESTGELD :
			{
				Festgeld* pFestgeld = theApp.GetSteMaBank()->identify_Festgeld(m_quellenummer);
				if (!pFestgeld)
				{
					AfxMessageBox("Quell-Festgeld nicht gefunden");
					return FALSE;
				}
				else 
				{
					m_quellebestand = pFestgeld->get_Bestand();
					m_quelletyp = "Festgeld";
					return TRUE;
				}
				break;
			}
			case SPARBUCH :
			{
				Sparbuch* pSparbuch = theApp.GetSteMaBank()->identify_Sparbuch(m_quellenummer);
				if (!pSparbuch)
				{
					AfxMessageBox("Quell-Sparbuch nicht gefunden");
					return FALSE;
				}
				else 
				{
					m_quellebestand = pSparbuch->get_Bestand();
					m_quelletyp = "Sparbuch";
					return TRUE;
				}
				break;
			}
			default : 
				AfxMessageBox("Quell-Einlage nicht gefunden");
				return FALSE;
		}

	}
	else
	{
		AfxMessageBox("Eingabedaten sind unvollstndig!");
		return FALSE;
	}

}
