// DialogEinlageLoeschen.cpp: Implementierungsdatei
//

#include "stdafx.h"
#include "SteMaBank.h"
#include "DialogEinlageLoeschen.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// Dialogfeld CDialogEinlageLoeschen 


CDialogEinlageLoeschen::CDialogEinlageLoeschen(CWnd* pParent /*=NULL*/)
	: CDialog(CDialogEinlageLoeschen::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDialogEinlageLoeschen)
	m_erstelldat = 0;
	m_typ = _T("");
	m_einlagenID = _T("");
	m_aktbestand = 0.0f;
	//}}AFX_DATA_INIT
}


void CDialogEinlageLoeschen::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDialogEinlageLoeschen)
	DDX_Control(pDX, IDOK, m_buttonok);
	DDX_DateTimeCtrl(pDX, IDC_DATETIMEPICKER_ERSTELLDAT, m_erstelldat);
	DDX_Text(pDX, IDC_EDIT_TYP, m_typ);
	DDX_Text(pDX, IDC_EDITEINLAGENID, m_einlagenID);
	DDV_MaxChars(pDX, m_einlagenID, 8);
	DDX_Text(pDX, IDC_EDIT_AKTBESTAND, m_aktbestand);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDialogEinlageLoeschen, CDialog)
	//{{AFX_MSG_MAP(CDialogEinlageLoeschen)
	ON_BN_CLICKED(IDC_BUTTONUEBERPRUEFEN, OnButtonueberpruefen)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Behandlungsroutinen fr Nachrichten CDialogEinlageLoeschen 

void CDialogEinlageLoeschen::OnButtonueberpruefen() 
{
	if (Check())
	{
		m_buttonok.EnableWindow(TRUE);
	}
	UpdateData(FALSE);
}

void CDialogEinlageLoeschen::OnOK() 
{
	
	if (Check())
	{
		if (theApp.GetSteMaBank()->del_Einlage(m_einlagenID))
			CDialog::OnOK();
		else
			AfxMessageBox("Einlage nicht leer");
	}
	
}

BOOL CDialogEinlageLoeschen::Check()
{
	UpdateData(TRUE);
	if (m_einlagenID.GetLength()!=8) 
	{
		AfxMessageBox("8-stellige Nummer erwartet!");
		return FALSE;
	}
	else
	{
	BYTE Typ = theApp.GetSteMaBank()->get_EinlagenTyp(m_einlagenID);
	switch (Typ)
	{
		case GIROKONTO : 
		{
			Girokonto* pGiro = theApp.GetSteMaBank()->identify_Girokonto(m_einlagenID);
			if (!pGiro)
			{
				AfxMessageBox("Einlage nicht gefunden");
				return FALSE;
			}
			else 
			{
				m_aktbestand = pGiro->get_Bestand();
				m_typ = "Girokonto";
				m_erstelldat = pGiro->get_Erstell_Dat();
				return TRUE;
			}
			break;
		}
		case FESTGELD :
		{
			Festgeld* pFestgeld = theApp.GetSteMaBank()->identify_Festgeld(m_einlagenID);
			if (!pFestgeld)
			{
				AfxMessageBox("Einlage nicht gefunden");
				return FALSE;
			}
			else 
			{
				m_aktbestand = pFestgeld->get_Bestand();
				m_typ = "Festgeld";
				m_erstelldat = pFestgeld->get_Erstell_Dat();
				return TRUE;
			}
			break;
		}
		case SPARBUCH :
		{
			Sparbuch* pSparbuch = theApp.GetSteMaBank()->identify_Sparbuch(m_einlagenID);
			if (!pSparbuch)
			{
				AfxMessageBox("Einlage nicht gefunden");
				return FALSE;
			}
			else 
			{
				m_aktbestand = pSparbuch->get_Bestand();
				m_typ = "Sparbuch";
				m_erstelldat = pSparbuch->get_Erstell_Dat();
				return TRUE;
			}
			break;
		}
		default : 
			AfxMessageBox("Einlage nicht gefunden");
			return FALSE;
	}
	}

} 


BOOL CDialogEinlageLoeschen::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	m_buttonok.EnableWindow(FALSE);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX-Eigenschaftenseiten sollten FALSE zurckgeben
}
