// DialogEinzahlung.cpp: Implementierungsdatei
//

#include "stdafx.h"
#include "SteMaBank.h"
#include "DialogEinzahlung.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// Dialogfeld CDialogEinzahlung 


CDialogEinzahlung::CDialogEinzahlung(CWnd* pParent /*=NULL*/)
	: CDialog(CDialogEinzahlung::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDialogEinzahlung)
	m_betrag = 0.0f;
	m_quellenummer = _T("");
	m_quelletyp = _T("");
	m_verwzweck = _T("");
	m_zielbestand = 0.0f;
	//}}AFX_DATA_INIT
}


void CDialogEinzahlung::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDialogEinzahlung)
	DDX_Control(pDX, IDOK, m_buttonok);
	DDX_Control(pDX, IDC_BUTTON_UEBERPRUEFEN, m_ueberpruefen);
	DDX_Text(pDX, IDC_EDIT_BETRAG, m_betrag);
	DDX_Text(pDX, IDC_EDIT_QUELLE_NR, m_quellenummer);
	DDV_MaxChars(pDX, m_quellenummer, 8);
	DDX_Text(pDX, IDC_EDIT_QUELLE_TYP, m_quelletyp);
	DDX_Text(pDX, IDC_EDIT_VERZWECK, m_verwzweck);
	DDX_Text(pDX, IDC_EDIT_ZIELBESTAND, m_zielbestand);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDialogEinzahlung, CDialog)
	//{{AFX_MSG_MAP(CDialogEinzahlung)
	ON_BN_CLICKED(IDC_BUTTON_UEBERPRUEFEN, OnButtonUeberpruefen)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Behandlungsroutinen fr Nachrichten CDialogEinzahlung 

BOOL CDialogEinzahlung::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	m_buttonok.EnableWindow(FALSE);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX-Eigenschaftenseiten sollten FALSE zurckgeben
}

void CDialogEinzahlung::OnOK() 
{
	if (CheckSettings())
	{
		Transaktion* pTransaktion = new Transaktion;
		pTransaktion->set_Typ(EINZAHLUNG);
		pTransaktion->set_Status(CHECKED);
		pTransaktion->set_Betrag(m_betrag);
		pTransaktion->set_Betreff(m_verwzweck);
		pTransaktion->set_QuelleZiel(0, "");
		pTransaktion->set_QuelleZiel(1, m_quellenummer);

		if (pTransaktion->executeAll())
		{
			//Einfgen in den Datenbestand der Bank
			theApp.GetSteMaBank()->new_Transaktion(pTransaktion);
			//Einfgen in die Transaktonsliste des Auftraggebers
			theApp.GetSteMaBank()->get_reg_Kunde()->new_Transaktion(pTransaktion->get_Transaktionsnummer());
			AfxMessageBox("Transaktion erfolgreich ausgefhrt!");
		}
		else
		{
			delete pTransaktion;
			AfxMessageBox("Transaktion fehlgeschlagen!");
		}
	
		CDialog::OnOK();
	}
		
	
}

void CDialogEinzahlung::OnButtonUeberpruefen() 
{
	if (CheckSettings())
	{
		m_buttonok.EnableWindow(TRUE);
	}
	
	UpdateData(FALSE);
}

BOOL CDialogEinzahlung::CheckSettings()
{
	UpdateData(TRUE);

	if ((m_verwzweck != "") && (m_quellenummer !=""))
	{
		BYTE Typ = 0;
		if (m_quellenummer.GetLength()>=5 )
			Typ = theApp.GetSteMaBank()->get_EinlagenTyp(m_quellenummer);
		else 
			AfxMessageBox("unvollstndige EinlagenID!");
		if (m_betrag <0.01)
		{
			AfxMessageBox("Einzahlungsbetrag unzulssig!");
			return FALSE;
		}
		switch (Typ)
		{
			case GIROKONTO : 
			{
				Girokonto* pGiro = theApp.GetSteMaBank()->identify_Girokonto(m_quellenummer);
				if (!pGiro)
				{
					AfxMessageBox("Ziel-Girokonto nicht gefunden");
					return FALSE;
				}
				else 
				{
					m_zielbestand = pGiro->get_Bestand();
					m_quelletyp = "Girokonto";
					return TRUE;
				}
				break;
			}
			case FESTGELD :
			{
				Festgeld* pFestgeld = theApp.GetSteMaBank()->identify_Festgeld(m_quellenummer);
				if (!pFestgeld)
				{
					AfxMessageBox("Ziel-Festgeld nicht gefunden");
					return FALSE;
				}
				else 
				{
					m_zielbestand = pFestgeld->get_Bestand();
					m_quelletyp = "Festgeld";
					return TRUE;
				}
				break;
			}
			case SPARBUCH :
			{
				Sparbuch* pSparbuch = theApp.GetSteMaBank()->identify_Sparbuch(m_quellenummer);
				if (!pSparbuch)
				{
					AfxMessageBox("Ziel-Sparbuch nicht gefunden");
					return FALSE;
				}
				else 
				{
					m_zielbestand = pSparbuch->get_Bestand();
					m_quelletyp = "Sparbuch";
					return TRUE;
				}
				break;
			}
			default : 
				AfxMessageBox("Ziel-Einlage nicht gefunden");
				return FALSE;
		}

	}
	else
	{
		AfxMessageBox("Eingabedaten sind unvollstndig!");
		return FALSE;
	}
}
