// DialogUeberweisung.cpp: Implementierungsdatei
//

#include "stdafx.h"
#include "SteMaBank.h"
#include "DialogUeberweisung.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// Dialogfeld CDialogUeberweisung 


CDialogUeberweisung::CDialogUeberweisung(CWnd* pParent /*=NULL*/)
	: CDialog(CDialogUeberweisung::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDialogUeberweisung)
	m_quellenummer = _T("");
	m_quelletyp = _T("");
	m_betrag = 0.0f;
	m_verwzweck = _T("");
	m_zielnummer = _T("");
	m_zielname = _T("");
	m_quellebestand = 0.0f;
	//}}AFX_DATA_INIT
}


void CDialogUeberweisung::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDialogUeberweisung)
	DDX_Control(pDX, IDOK, m_buttonok);
	DDX_Control(pDX, IDC_BUTTON_UEBERPRUEFEN, m_buttonueber);
	DDX_Text(pDX, IDC_EDIT_QUELLE_NR, m_quellenummer);
	DDV_MaxChars(pDX, m_quellenummer, 8);
	DDX_Text(pDX, IDC_EDIT_QUELLE_TYP, m_quelletyp);
	DDX_Text(pDX, IDC_EDIT_BETRAG, m_betrag);
	DDV_MinMaxFloat(pDX, m_betrag, 1.e-002f, 1.e+007f);
	DDX_Text(pDX, IDC_EDIT_VERZWECK, m_verwzweck);
	DDX_Text(pDX, IDC_EDIT_ZIEL_EINLID, m_zielnummer);
	DDV_MaxChars(pDX, m_zielnummer, 8);
	DDX_Text(pDX, IDC_EDIT_ZIEL_NAME, m_zielname);
	DDX_Text(pDX, IDC_EDIT_QUELLEBESTAND, m_quellebestand);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDialogUeberweisung, CDialog)
	//{{AFX_MSG_MAP(CDialogUeberweisung)
	ON_BN_CLICKED(IDC_BUTTON_UEBERPRUEFEN, OnButtonUeberpruefen)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Behandlungsroutinen fr Nachrichten CDialogUeberweisung 

BOOL CDialogUeberweisung::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	m_buttonok.EnableWindow(FALSE);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX-Eigenschaftenseiten sollten FALSE zurckgeben
}

void CDialogUeberweisung::OnOK() 
{
	if (CheckSettings())
	{
		Transaktion* pTransaktion = new Transaktion;
		pTransaktion->set_Typ(UEBERWEISUNG);
		pTransaktion->set_Status(CHECKED);
		pTransaktion->set_Betrag(m_betrag);
		pTransaktion->set_Betreff(m_verwzweck);
		pTransaktion->set_QuelleZiel(0, m_quellenummer);
		pTransaktion->set_QuelleZiel(1, m_zielnummer);

		if (pTransaktion->executeAll())
		{
			//Einfgen in den Datenbestand der Bank
			theApp.GetSteMaBank()->new_Transaktion(pTransaktion);
			//Einfgen in die Transaktonsliste des Auftraggebers
			theApp.GetSteMaBank()->get_reg_Kunde()->new_Transaktion(pTransaktion->get_Transaktionsnummer());
			AfxMessageBox("Transaktion erfolgreich ausgefhrt!");
		}
		else
		{
			delete pTransaktion;
			AfxMessageBox("Transaktion fehlgeschlagen!");
		}
	
		CDialog::OnOK();
	}
}

void CDialogUeberweisung::OnButtonUeberpruefen() 
{
	if (CheckSettings())
	{
		m_buttonok.EnableWindow(TRUE);
	}
	
	UpdateData(FALSE);
}

BOOL CDialogUeberweisung::CheckSettings()
{
	UpdateData(TRUE);

	if ((m_verwzweck != "") && (m_quellenummer !="") && (m_zielnummer !="") && (m_zielname!=""))
	{
		BYTE Typquelle = 0;
		BYTE Typziel = 0;
		if ((m_quellenummer.GetLength()>=5 ) && (m_quellenummer.GetLength()>=5 ))
		{
			Typquelle = theApp.GetSteMaBank()->get_EinlagenTyp(m_quellenummer);
			Typziel = theApp.GetSteMaBank()->get_EinlagenTyp(m_zielnummer);
		}
		else 
			AfxMessageBox("unvollstndige EinlagenID bei Quelle oder Ziel!");

		if (m_betrag <0.01)
		{
			AfxMessageBox("Einzahlungsbetrag unzulssig!");
			return FALSE;
		}
		switch (Typquelle)
		{
			case GIROKONTO : 
			{
				Girokonto* pGiro = theApp.GetSteMaBank()->identify_Girokonto(m_quellenummer);
				if (!pGiro)
				{
					AfxMessageBox("Quell-Girokonto nicht gefunden");
					return FALSE;
				}
				else 
				{
					m_quellebestand = pGiro->get_Bestand();
					m_quelletyp = "Girokonto";
					return TRUE;
				}
				break;
			}
			case FESTGELD :
			{
				Festgeld* pFestgeld = theApp.GetSteMaBank()->identify_Festgeld(m_quellenummer);
				if (!pFestgeld)
				{
					AfxMessageBox("Quell-Festgeld nicht gefunden");
					return FALSE;
				}
				else 
				{
					m_quellebestand = pFestgeld->get_Bestand();
					m_quelletyp = "Festgeld";
					return TRUE;
				}
				break;
			}
			case SPARBUCH :
			{
				Sparbuch* pSparbuch = theApp.GetSteMaBank()->identify_Sparbuch(m_quellenummer);
				if (!pSparbuch)
				{
					AfxMessageBox("Quell-Sparbuch nicht gefunden");
					return FALSE;
				}
				else 
				{
					m_quellebestand = pSparbuch->get_Bestand();
					m_quelletyp = "Sparbuch";
					return TRUE;
				}
				break;
			}
			default : 
				AfxMessageBox("Quell-Einlage nicht gefunden");
				return FALSE;
		} //end switch
		//////////////////////////////////////////////////////////////
		switch (Typziel)
		{
			case GIROKONTO : 
			{
				Girokonto* pGiro = theApp.GetSteMaBank()->identify_Girokonto(m_zielnummer);
				if (!pGiro)
				{
					AfxMessageBox("Ziel-Girokonto nicht gefunden");
					return FALSE;
				}
				else 
				{
					Kunde* pZielInhaber = theApp.GetSteMaBank()->identify_Inhaber(m_zielnummer);
			
					if ((pZielInhaber)&&(pZielInhaber->get_Name() != m_zielname))
					{
						AfxMessageBox("Empfngername nicht korrekt!");
						return FALSE;
					}
					else return TRUE;
				}
				break;
			}
			case FESTGELD :
			{
				Festgeld* pFestgeld = theApp.GetSteMaBank()->identify_Festgeld(m_quellenummer);
				if (!pFestgeld)
				{
					AfxMessageBox("Ziel-Festgeld nicht gefunden");
					return FALSE;
				}
				else 
				{
					Kunde* pZielInhaber = theApp.GetSteMaBank()->identify_Inhaber(m_zielnummer);
					if ((pZielInhaber)&&(pZielInhaber->get_Name() != m_zielname))
					{
						AfxMessageBox("Empfnger nicht korrekt!");
						return FALSE;
					}
					else return TRUE;
				}
				break;
			}
			case SPARBUCH :
			{
				Sparbuch* pSparbuch = theApp.GetSteMaBank()->identify_Sparbuch(m_quellenummer);
				if (!pSparbuch)
				{
					AfxMessageBox("Ziel-Sparbuch nicht gefunden");
					return FALSE;
				}
				else 
				{
					Kunde* pZielInhaber = theApp.GetSteMaBank()->identify_Inhaber(m_zielnummer);
					if ((pZielInhaber)&&(pZielInhaber->get_Name() != m_zielname))

					{
						AfxMessageBox("Empfnger nicht korrekt!");
						return FALSE;
					}
					else return TRUE;
				}
				break;
			}
			default : 
				AfxMessageBox("Ziel-Einlage nicht gefunden");
				return FALSE;
		}//end switch
	}
	else
	{
		AfxMessageBox("Eingabedaten sind unvollstndig!");
		return FALSE;
	}
}
