//## begin module.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module.cm

//## begin module.cp preserve=no
//## end module.cp

//## Module: Einlage; Package body
//	Quellcodedatei
//## Subsystem: <Top Level>
//	Dateistruktur des Projektes mit Header- ud
//	Quellcodedateien
//	Erzeugte Dateien werden in MS-VC++ 6.0 Project
//	bernommen und dort ausprogrammiert
//	Der zustzlich  erzeugte Code bleibt auch nach
//	Hinzufgen von Komponenten im Modell erhalten!
//## Source file: c:\daten\uni\sofwaretechnik\stemabank\Einlage.cpp


//## begin module.additionalIncludes preserve=no
//## end module.additionalIncludes

//## begin module.includes preserve=yes
#include "StdAfx.h"
#include "SteMaBank.h"

//## end module.includes

// Einlage
#include "Einlage.h"

//## begin module.declarations preserve=no
//## end module.declarations

//## begin module.additionalDeclarations preserve=yes
		IMPLEMENT_SERIAL(Einlage, CObject, 1)
//## end module.additionalDeclarations


// Class Einlage 






//## begin Einlage::LastEinlagenID.attr preserve=no  public: static int {U} 
int Einlage::LastEinlagenID;
//## end Einlage::LastEinlagenID.attr


Einlage::Einlage()
  //## begin Einlage::Einlage%.hasinit preserve=no
      : Status(TRUE), Bestand(0), Verzinsung(0)
  //## end Einlage::Einlage%.hasinit
  //## begin Einlage::Einlage%.initialization preserve=yes
  //## end Einlage::Einlage%.initialization
{
  //## begin Einlage::Einlage%.body preserve=yes
	LastEinlagenID++;
	Einlagennummer.Format("%3.3d",LastEinlagenID);
  //## end Einlage::Einlage%.body
}

Einlage::Einlage(const Einlage &right)
  //## begin Einlage::Einlage%copy.hasinit preserve=no
      : Status(TRUE), Bestand(0), Verzinsung(0)
  //## end Einlage::Einlage%copy.hasinit
  //## begin Einlage::Einlage%copy.initialization preserve=yes
  //## end Einlage::Einlage%copy.initialization
{
  //## begin Einlage::Einlage%copy.body preserve=yes
  //## end Einlage::Einlage%copy.body
}


Einlage::~Einlage()
{
  //## begin Einlage::~Einlage%.body preserve=yes
  //## end Einlage::~Einlage%.body
}



//## Other Operations (implementation)
BOOL Einlage::gen_EinlagenID(Kunde* pKunde, BYTE Typ)
{
  //## begin Einlage::gen_EinlagenID%937416389.body preserve=yes
	CString KundeID;
	KundeID=pKunde->get_Kundennummer ();
	Einlagennummer.Insert(0,KundeID);
	switch (Typ)
	{
		case SPARBUCH:
		{
			Einlagennummer.Insert(KundeID.GetLength(),"0");
			break;
		}
		case GIROKONTO:
		{
			Einlagennummer.Insert(KundeID.GetLength(),"4");
			break;
		}
		case FESTGELD:
		{
			Einlagennummer.Insert(KundeID.GetLength(),"8");
			break;
		}
	} //end switch
	return TRUE;
  //## end Einlage::gen_EinlagenID%937416389.body
}

BYTE Einlage::get_Type()
{
  //## begin Einlage::get_Type%937416390.body preserve=yes
	TCHAR Typ;
	Typ=Einlagennummer.GetAt(4); 
	switch (Typ)
	{
	case '0':
		return SPARBUCH;
		break;
	case '4':
		return GIROKONTO;
		break;
	case '8':
		return FESTGELD;
		break;
	default:
		return 0;
		break;
	} //end switch
  //## end Einlage::get_Type%937416390.body
}

BOOL Einlage::check(float Betrag)
{
  //## begin Einlage::check%937474104.body preserve=yes
	if ((get_Bestand()+Betrag)>=0)	
		return TRUE;
	else 
		return FALSE;
  //## end Einlage::check%937474104.body
}

BOOL Einlage::updateBestand(float Betrag)
{
  //## begin Einlage::updateBestand%937474110.body preserve=yes
	set_Bestand(get_Bestand()+Betrag);
	return TRUE;
  //## end Einlage::updateBestand%937474110.body
}

float Einlage::zinsen(int Monate)
{
  //## begin Einlage::zinsen%937734172.body preserve=yes
	
	return (Monate*get_Bestand()/12);
	
  //## end Einlage::zinsen%937734172.body
}

void Einlage::Serialize(CArchive& ar)
{
  //## begin Einlage::Serialize%937866640.body preserve=yes
	CObject::Serialize( ar );

    if( ar.IsStoring() )
    {
		ar << Bestand;
		ar << Einlagennummer;
		ar << Erstell_Dat;
		ar << Status;
		ar << Verzinsung;
		ar << InhaberID;
	}
	else
	{
    	ar >> Bestand;
		ar >> Einlagennummer;
		ar >> Erstell_Dat;
		ar >> Status;
		ar >> Verzinsung;
		ar >> InhaberID;
	}	
  //## end Einlage::Serialize%937866640.body
}


// Additional Declarations
//## begin Einlage.declarations preserve=yes
//## end Einlage.declarations




