//## begin module.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module.cm

//## begin module.cp preserve=no
//## end module.cp

//## Module: Festgeld; Package specification
//	Headerfile
//## Subsystem: <Top Level>
//	Dateistruktur des Projektes mit Header- ud
//	Quellcodedateien
//	Erzeugte Dateien werden in MS-VC++ 6.0 Project
//	bernommen und dort ausprogrammiert
//	Der zustzlich  erzeugte Code bleibt auch nach
//	Hinzufgen von Komponenten im Modell erhalten!
//## Source file: c:\daten\uni\sofwaretechnik\stemabank\Festgeld.h


#ifndef Festgeld_h
#define Festgeld_h 1

//## begin module.additionalIncludes preserve=no
//## end module.additionalIncludes

//## begin module.includes preserve=yes
//## end module.includes

// Einlage
#include "Einlage.h"
// globals
#include "globals.h"

//## begin module.declarations preserve=no
//## end module.declarations

//## begin module.additionalDeclarations preserve=yes
//## end module.additionalDeclarations


//## Class: Festgeld
//	Festgeldeinlage, deren Verzinsung mit zunehmender
//	Laufzeit steigt
//## Category: Kunden und Einlagenverwaltung
//## Subsystem: <Top Level>
//## Persistence: Transient
//## Cardinality/Multiplicity: n


class Festgeld : public Einlage  //## Inherits: Generalisierung

{
  //## begin Festgeld.initialDeclarations preserve=yes
  //## end Festgeld.initialDeclarations

  public:
    //## Constructors (generated)
      Festgeld();

      Festgeld(const Festgeld &right);

    //## Destructor (generated)
      ~Festgeld();


    //## Other Operations (specified)
      //## Operation: check%937474107
      //	berladene verfeinerte berprfungsfunktion von Einlage
      BOOL check(float Betrag = 0);

      //## Operation: akt_Bestand%937734173
      //	Berechnet den mit Zinsen erhhten Bestand fr die
      //	bergebene Laufzeit in Jahren und gibt diese zurck.
      //	Bei keiner Parameterbergabe wird die gesamte Laufzeit
      //	genommen!
      //	Der neue Bestand wird nicht gespeichert!
      float akt_Bestand(int Jahre = -1);

      //## Operation: zinsen%937734174
      //	Berechnet die Zinsen fr die bergebenen Jahre und gibt
      //	diese zurck. Bei keiner Parameterbergabe werden die
      //	Zinsen fr die gesamte Laufzeit errechnet. Der Bestand
      //	wird nicht verndert!
      virtual float zinsen(int Jahre = -1);

      //## Operation: Serialize%937866642
      //	jede Datenklasse besitzt ihr eigene
      //	Serialisierungsfunktion.
      //	sie dient zur permanenten Speicherung des gesammten
      //	Datenbestandes der Bank.
      //	jede Klasse serialisiert sich praktisch selbst, indem
      //	sie ihre Daten serialisiert.
      void Serialize(CArchive& ar);

    //## Get and Set Operations for Class Attributes (generated)

      //## Attribute: Laufzeit
      //	Membervariable
      //	Laufzeit der Geldanlage in Jahren
      int get_Laufzeit();
      void set_Laufzeit(const int value);

    // Additional Public Declarations
      //## begin Festgeld.public preserve=yes
	  	DECLARE_SERIAL(Festgeld)
      //## end Festgeld.public


  protected:
    // Additional Protected Declarations
      //## begin Festgeld.protected preserve=yes
      //## end Festgeld.protected


  private:
    // Additional Private Declarations
      //## begin Festgeld.private preserve=yes
      //## end Festgeld.private


  private:  //## implementation
    // Data Members for Class Attributes

      //## begin Festgeld::Laufzeit.attr preserve=no  public: int {U} 
      int Laufzeit;
      //## end Festgeld::Laufzeit.attr

    // Additional Implementation Declarations
      //## begin Festgeld.implementation preserve=yes
      //## end Festgeld.implementation

};



// Class Festgeld 

//## Get and Set Operations for Class Attributes (inline)

inline int Festgeld::get_Laufzeit()
{
  //## begin Festgeld::get_Laufzeit%.get preserve=no
  return Laufzeit;
  //## end Festgeld::get_Laufzeit%.get
}

inline void Festgeld::set_Laufzeit(const int value)
{
  //## begin Festgeld::set_Laufzeit%.set preserve=no
  Laufzeit = value;
  //## end Festgeld::set_Laufzeit%.set
}





#endif


