//## begin module.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module.cm

//## begin module.cp preserve=no
//## end module.cp

//## Module: Girokonto; Package specification
//	Headerfile
//## Subsystem: <Top Level>
//	Dateistruktur des Projektes mit Header- ud
//	Quellcodedateien
//	Erzeugte Dateien werden in MS-VC++ 6.0 Project
//	bernommen und dort ausprogrammiert
//	Der zustzlich  erzeugte Code bleibt auch nach
//	Hinzufgen von Komponenten im Modell erhalten!
//## Source file: c:\daten\uni\sofwaretechnik\stemabank\Girkonto.h


#ifndef Girkonto_h
#define Girkonto_h 1

//## begin module.additionalIncludes preserve=no
//## end module.additionalIncludes

//## begin module.includes preserve=yes
//## end module.includes

// Einlage
#include "Einlage.h"
// globals
#include "globals.h"

//## begin module.declarations preserve=no
//## end module.declarations

//## begin module.additionalDeclarations preserve=yes
//## end module.additionalDeclarations


//## Class: Girokonto
//	Girokonto, wie allgemein gebruchlich
//## Category: Kunden und Einlagenverwaltung
//## Subsystem: <Top Level>
//## Persistence: Transient
//## Cardinality/Multiplicity: n


class Girokonto : public Einlage  //## Inherits: Generalisierung

{
  //## begin Girokonto.initialDeclarations preserve=yes
  //## end Girokonto.initialDeclarations

  public:
    //## Constructors (generated)
      Girokonto();

      Girokonto(const Girokonto &right);

    //## Destructor (generated)
      ~Girokonto();


    //## Other Operations (specified)
      //## Operation: check%937474105
      //	berladene berprfungsfunktion von Einlage
      BOOL check(float Betrag = 0);

      //## Operation: Serialize%937866644
      //	jede Datenklasse besitzt ihr eigene
      //	Serialisierungsfunktion.
      //	sie dient zur permanenten Speicherung des gesammten
      //	Datenbestandes der Bank.
      //	jede Klasse serialisiert sich praktisch selbst, indem
      //	sie ihre Daten serialisiert.
      void Serialize(CArchive& ar);

    //## Get and Set Operations for Class Attributes (generated)

      //## Attribute: Dispo
      //	Membervariable
      //	Dispokredit des Kontos
      float get_Dispo();
      void set_Dispo(const float value);

    // Additional Public Declarations
      //## begin Girokonto.public preserve=yes
	  	DECLARE_SERIAL(Girokonto)
      //## end Girokonto.public


  protected:
    // Additional Protected Declarations
      //## begin Girokonto.protected preserve=yes
      //## end Girokonto.protected


  private:
    // Additional Private Declarations
      //## begin Girokonto.private preserve=yes
      //## end Girokonto.private


  private:  //## implementation
    // Data Members for Class Attributes

      //## begin Girokonto::Dispo.attr preserve=no  public: float {U} 0
      float Dispo;
      //## end Girokonto::Dispo.attr

    // Additional Implementation Declarations
      //## begin Girokonto.implementation preserve=yes
      //## end Girokonto.implementation

};



// Class Girokonto 

//## Get and Set Operations for Class Attributes (inline)

inline float Girokonto::get_Dispo()
{
  //## begin Girokonto::get_Dispo%.get preserve=no
  return Dispo;
  //## end Girokonto::get_Dispo%.get
}

inline void Girokonto::set_Dispo(const float value)
{
  //## begin Girokonto::set_Dispo%.set preserve=no
  Dispo = value;
  //## end Girokonto::set_Dispo%.set
}





#endif


