//## begin module.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module.cm

//## begin module.cp preserve=no
//## end module.cp

//## Module: Kunde; Package specification
//	Headerfile
//## Subsystem: <Top Level>
//	Dateistruktur des Projektes mit Header- ud
//	Quellcodedateien
//	Erzeugte Dateien werden in MS-VC++ 6.0 Project
//	bernommen und dort ausprogrammiert
//	Der zustzlich  erzeugte Code bleibt auch nach
//	Hinzufgen von Komponenten im Modell erhalten!
//## Source file: c:\daten\uni\sofwaretechnik\stemabank\Kunde.h


#ifndef Kunde_h
#define Kunde_h 1

//## begin module.additionalIncludes preserve=no
//## end module.additionalIncludes

//## begin module.includes preserve=yes
//## end module.includes

// globals
#include "globals.h"

//## begin module.declarations preserve=no
//## end module.declarations

//## begin module.additionalDeclarations preserve=yes
//## end module.additionalDeclarations


//## Class: Kunde
//	Person, die bei der Bank Geldeinlagen besitzt,
//	Transaktionen und andere Anweisungen auf diese
//	durchfhren kann
//## Category: Kunden und Einlagenverwaltung
//## Subsystem: <Top Level>
//## Persistence: Transient
//## Cardinality/Multiplicity: n


class Kunde : public MFCOBJECT  //## Inherits: Subklasse von

{
  //## begin Kunde.initialDeclarations preserve=yes
  //## end Kunde.initialDeclarations

  public:
    //## Constructors (generated)
      Kunde();

    //## Constructors (specified)
      //## Operation: Kunde%936893244
      //	zweiter Konstruktor,
      //	bergebene Parameter werden in Membervariablen
      //	gespeichert
      Kunde(CString name, CString vorname, CString gebdat, CString anschrift);

    //## Destructor (generated)
      ~Kunde();


    //## Other Operations (specified)
      //## Operation: new_Einlage%936879561
      //	Speichert eine EinlagenID in das CArray Einlagen, das
      //	die Einlagennummern der gesamten Einlagen eines Kunden
      //	speichert!
      //	liefert TRUE oder FALSE zurck
      BOOL new_Einlage(EinlagenID EinlID);

      //## Operation: new_Transaktion%937432489
      //	Liefert nach Eintrag einer TransaktionsID in das CArray
      //	Transaktionen beim Kunde einen Erfolgswert zurck
      //	(TRUE,FALSE)
      BOOL new_Transaktion(TransaktionsID TransID);

      //## Operation: del_Einlage%937583335
      //	Lscht bergebene EinlagenID aus Einlagenspeicher
      //	Liefert Erfolg zurck
      //	(TRUE,FALSE)
      BOOL del_Einlage(EinlagenID Einlage = "");

      //## Operation: del_Transakt%937583336
      //	Lscht bergebene TransaktionsID aus
      //	Transaktionenspeicher
      //	Liefert Erfolg zurck
      //	(TRUE,FALSE)
      BOOL del_Transakt(TransaktionsID Transaktion = "");

      //## Operation: Serialize%937866639
      //	jede Datenklasse besitzt ihr eigene
      //	Serialisierungsfunktion.
      //	sie dient zur permanenten Speicherung des gesammten
      //	Datenbestandes der Bank.
      //	jede Klasse serialisiert sich praktisch selbst, indem
      //	sie ihre Daten serialisiert.
      void Serialize(CArchive& ar);

    //## Get and Set Operations for Has Relationships (generated)

      //## Documentation Kunde::Kundennummer.has
      //	Eindeutige KundenID wird beim Kunden per Wert
      //	gespeichert. (Kunde besitzt KundenID- Objekt!)
      const KundenID get_Kundennummer() const;

    //## Get and Set Operations for Class Attributes (generated)

      //## Attribute: Name
      //	Membervariable:
      //	Nachname des Kunden
      const CString get_Name() const;
      void set_Name(const CString value);

      //## Attribute: Vorname
      //	Membervariable
      const CString get_Vorname() const;
      void set_Vorname(const CString value);

      //## Attribute: Geb_Dat
      //	Membervariable
      const CString get_Geb_Dat() const;
      void set_Geb_Dat(const CString value);

      //## Attribute: Anschrift
      //	Membervariable
      //	speichert gesamte Anschrift in eine Variable vom Typ
      //	CString
      const CString get_Anschrift() const;
      void set_Anschrift(const CString value);

      //## Attribute: LastKundenID
      //	Klassenvariable zur automatischen Generierung einer
      //	Kundennummer bei Erstellung eines Kundenobjektes,
      //	zhlt im Prinzip die erzeugten Objekte,
      //	im Konstruktor wird hochgezhlt und in KundenID Objekt
      //	(CString) umgewandelt.
      static int get_LastKundenID();

    //## Get and Set Operations for Associations (generated)

      //## Association: KundenEinlagenID%37D7A4FF022B
      //## Role: Kunde::Einlagen
      const CArray<EinlagenID,EinlagenID>* get_Einlagen() const;

      //## Association: KundeTransRel%37E01B3401CC
      //## Role: Kunde::Transaktionen
      CArray<TransaktionsID,TransaktionsID>* get_Transaktionen();

    // Additional Public Declarations
      //## begin Kunde.public preserve=yes
	  	DECLARE_SERIAL(Kunde)
      //## end Kunde.public


  protected:
    // Additional Protected Declarations
      //## begin Kunde.protected preserve=yes
      //## end Kunde.protected


  private:
    // Additional Private Declarations
      //## begin Kunde.private preserve=yes
      //## end Kunde.private


  private:  //## implementation
    // Data Members for Has Relationships

      //## begin Kunde::Kundennummer.has preserve=no  public: KundenID {1 -> 1VO}
      KundenID Kundennummer;
      //## end Kunde::Kundennummer.has

    // Data Members for Class Attributes

      //## begin Kunde::Name.attr preserve=no  public: CString {U} ""
      CString Name;
      //## end Kunde::Name.attr

      //## begin Kunde::Vorname.attr preserve=no  public: CString {U} ""
      CString Vorname;
      //## end Kunde::Vorname.attr

      //## begin Kunde::Geb_Dat.attr preserve=no  public: CString {U} ""
      CString Geb_Dat;
      //## end Kunde::Geb_Dat.attr

      //## begin Kunde::Anschrift.attr preserve=no  public: CString {U} ""
      CString Anschrift;
      //## end Kunde::Anschrift.attr

      //## begin Kunde::LastKundenID.attr preserve=no  public: static int {U} 
      static int LastKundenID;
      //## end Kunde::LastKundenID.attr

    // Data Members for Associations

      //## Association: Bank_Kunde_Rel%3770AB8801E0
      //## Role: Kunde::nutzt
      //## begin Kunde::nutzt.role preserve=no  public: Bank {0..n -> 1..1RH}
      //## end Kunde::nutzt.role

      //## Association: KundenEinlagenID%37D7A4FF022B
      //## begin Kunde::Einlagen.role preserve=no  public: EinlagenID {1..1 -> 1..nVHN}
      CArray<EinlagenID,EinlagenID>* Einlagen;
      //## end Kunde::Einlagen.role

      //## Association: KundeTransRel%37E01B3401CC
      //## begin Kunde::Transaktionen.role preserve=no  public: TransaktionsID {1..2 -> 0..nVHN}
      CArray<TransaktionsID,TransaktionsID>* Transaktionen;
      //## end Kunde::Transaktionen.role

    // Additional Implementation Declarations
      //## begin Kunde.implementation preserve=yes
      //## end Kunde.implementation

};



// Class Kunde 

//## Get and Set Operations for Has Relationships (inline)

inline const KundenID Kunde::get_Kundennummer() const
{
  //## begin Kunde::get_Kundennummer%.get preserve=no
  return Kundennummer;
  //## end Kunde::get_Kundennummer%.get
}

//## Get and Set Operations for Class Attributes (inline)

inline const CString Kunde::get_Name() const
{
  //## begin Kunde::get_Name%.get preserve=no
  return Name;
  //## end Kunde::get_Name%.get
}

inline void Kunde::set_Name(const CString value)
{
  //## begin Kunde::set_Name%.set preserve=no
  Name = value;
  //## end Kunde::set_Name%.set
}

inline const CString Kunde::get_Vorname() const
{
  //## begin Kunde::get_Vorname%.get preserve=no
  return Vorname;
  //## end Kunde::get_Vorname%.get
}

inline void Kunde::set_Vorname(const CString value)
{
  //## begin Kunde::set_Vorname%.set preserve=no
  Vorname = value;
  //## end Kunde::set_Vorname%.set
}

inline const CString Kunde::get_Geb_Dat() const
{
  //## begin Kunde::get_Geb_Dat%.get preserve=no
  return Geb_Dat;
  //## end Kunde::get_Geb_Dat%.get
}

inline void Kunde::set_Geb_Dat(const CString value)
{
  //## begin Kunde::set_Geb_Dat%.set preserve=no
  Geb_Dat = value;
  //## end Kunde::set_Geb_Dat%.set
}

inline const CString Kunde::get_Anschrift() const
{
  //## begin Kunde::get_Anschrift%.get preserve=no
  return Anschrift;
  //## end Kunde::get_Anschrift%.get
}

inline void Kunde::set_Anschrift(const CString value)
{
  //## begin Kunde::set_Anschrift%.set preserve=no
  Anschrift = value;
  //## end Kunde::set_Anschrift%.set
}

inline int Kunde::get_LastKundenID()
{
  //## begin Kunde::get_LastKundenID%.get preserve=no
  return LastKundenID;
  //## end Kunde::get_LastKundenID%.get
}

//## Get and Set Operations for Associations (inline)

inline const CArray<EinlagenID,EinlagenID>* Kunde::get_Einlagen() const
{
  //## begin Kunde::get_Einlagen%.get preserve=no
  return Einlagen;
  //## end Kunde::get_Einlagen%.get
}

inline CArray<TransaktionsID,TransaktionsID>* Kunde::get_Transaktionen()
{
  //## begin Kunde::get_Transaktionen%.get preserve=no
  return Transaktionen;
  //## end Kunde::get_Transaktionen%.get
}





#endif


