// MainFrm.cpp : Implementierung der Klasse CMainFrame
//

#include "stdafx.h"
#include "SteMaBank.h"
#include "MainFrm.h"
#include "DialogKundeNeu.h"
#include "DialogKundeAn.h"
#include "DialogKundenAnzeigen.h"
#include "DialogAktKunde.h"

#include "DialogNewFestgeld.h"
#include "DialogNewSparbuch.h"
#include "DialogNewGiro.h"
#include "DialogEinlageLoeschen.h"

#include "DialogAuszahlung.h"
#include "DialogEinzahlung.h"
#include "DialogUeberweisung.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNAMIC(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_WM_SETFOCUS()
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
	ON_COMMAND(ID_KUNDENVERWALTUNG_NEUERKUNDE, OnKundenverwaltungNeuerkunde)
	ON_COMMAND(ID_KUNDENVERWALTUNG_KUNDEANMELDEN, OnKundenverwaltungKundeanmelden)
	ON_COMMAND(ID_KUNDENVERWALTUNG_KUNDENSTAMM, OnKundenverwaltungKundenstamm)
	ON_COMMAND(ID_KUNDENVERWALTUNG_KUNDELSCHEN, OnKundenverwaltungKundelschen)
	ON_COMMAND(ID_EINLAGENVERWALTUNG_NEUEEINLAGE_FESTGELD, OnEinlagenverwaltungNeueeinlageFestgeld)
	ON_COMMAND(ID_EINLAGENVERWALTUNG_NEUEEINLAGE_SPARBUCH, OnEinlagenverwaltungNeueeinlageSparbuch)
	ON_COMMAND(ID_EINLAGENVERWALTUNG_NEUEEINLAGE_GIRO, OnEinlagenverwaltungNeueeinlageGiro)
	ON_COMMAND(ID_EINLAGENVERWALTUNG_LSCHEN, OnEinlagenverwaltungLschen)
	ON_COMMAND(ID_AUFTRAGSVERWALTUNG_NEU_AUSZAHLUNG, OnAuftragsverwaltungNeuAuszahlung)
	ON_COMMAND(ID_AUFTRAGSVERWALTUNG_NEU_BERWEISUNG, OnAuftragsverwaltungNeuBerweisung)
	ON_COMMAND(ID_AUFTRAGSVERWALTUNG_NEU_EINZAHLUNG, OnAuftragsverwaltungNeuEinzahlung)
	ON_COMMAND(ID_KUNDENVERWALTUNG_BEARBEITEN, OnKundenverwaltungBearbeiten)
	ON_UPDATE_COMMAND_UI_RANGE(ID_KUNDENVERWALTUNG_NEUERKUNDE, ID_KUNDENVERWALTUNG_BEARBEITEN, OnUpdateKunde)
	ON_UPDATE_COMMAND_UI_RANGE(ID_EINLAGENVERWALTUNG_NEUEEINLAGE_GIRO,ID_EINLAGENVERWALTUNG_NEUEEINLAGE_FESTGELD,OnUpdateEinlage)
	ON_UPDATE_COMMAND_UI_RANGE(ID_AUFTRAGSVERWALTUNG_NEU_BERWEISUNG,ID_AUFTRAGSVERWALTUNG_NEU_AUSZAHLUNG,OnUpdateAuftraege)
	ON_UPDATE_COMMAND_UI_RANGE(ID_EINLAGENVERWALTUNG_NEUEEINLAGE,ID_EINLAGENVERWALTUNG_LSCHEN,OnUpdateEinlagenverwaltung)

	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // Statusleistenanzeige
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame Konstruktion/Zerstrung

CMainFrame::CMainFrame()
{
	m_pAktKundenDlg =NULL;
}

CMainFrame::~CMainFrame()
{

}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	// create a view to occupy the client area of the frame
	if (!m_wndView.Create(NULL, NULL, AFX_WS_DEFAULT_VIEW,
		CRect(0, 0, 0, 0), this, AFX_IDW_PANE_FIRST, NULL))
	{
		TRACE0("Failed to create view window\n");
		return -1;
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Statusleiste konnte nicht erstellt werden\n");
		return -1;      // Fehler bei Erstellung
	}

	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	// ZU ERLEDIGEN: ndern Sie hier die Fensterklasse oder das Erscheinungsbild, indem Sie
	//  CREATESTRUCT cs modifizieren.

	cs.dwExStyle &= ~WS_EX_CLIENTEDGE;
	cs.lpszClass = AfxRegisterWndClass(0);
	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame Diagnose

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame Nachrichten-Handler
void CMainFrame::OnSetFocus(CWnd* pOldWnd)
{
	// Fokus an das Ansichtfenster weitergeben
	m_wndView.SetFocus();
}

BOOL CMainFrame::OnCmdMsg(UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo)
{
	// Ansichtfenster erhlt ersten Eindruck vom Befehl
	if (m_wndView.OnCmdMsg(nID, nCode, pExtra, pHandlerInfo))
		return TRUE;

	// andernfalls die Standardbehandlung durchfhren
	return CFrameWnd::OnCmdMsg(nID, nCode, pExtra, pHandlerInfo);
}


void CMainFrame::OnUpdateKunde(CCmdUI* pCmdUI)
{
	switch(pCmdUI->m_nID)
	{
	case ID_KUNDENVERWALTUNG_KUNDEANMELDEN:
		if (theApp.GetSteMaBank()->get_reg_Kunde() != NULL)
			pCmdUI->SetText(_T("&Kunde abmelden"));
		else 
			pCmdUI->SetText(_T("&Kunde anmelden"));
		pCmdUI->Enable();
		break;

	case ID_KUNDENVERWALTUNG_NEUERKUNDE:
		if (theApp.GetSteMaBank()->get_reg_Kunde() != NULL)
			pCmdUI->Enable(FALSE);
		else
			pCmdUI->Enable();
		break;
	
	case ID_KUNDENVERWALTUNG_KUNDELSCHEN:
		if (theApp.GetSteMaBank()->get_reg_Kunde() != NULL)
			pCmdUI->Enable();
		else
			pCmdUI->Enable(FALSE);
		break;
	case ID_KUNDENVERWALTUNG_BEARBEITEN:
		if (theApp.GetSteMaBank()->get_reg_Kunde() != NULL)
			pCmdUI->Enable();
		else
			pCmdUI->Enable(FALSE);
		break;
	case ID_EINLAGENVERWALTUNG_NEUEEINLAGE:
		if (theApp.GetSteMaBank()->get_reg_Kunde() != NULL)
			pCmdUI->Enable();
		else
			pCmdUI->Enable(FALSE);
		break;

	} //end switch
}

void CMainFrame::OnUpdateEinlage(CCmdUI* pCmdUI)
{
	switch(pCmdUI->m_nID)
	{
	case ID_EINLAGENVERWALTUNG_NEUEEINLAGE:
		if (theApp.GetSteMaBank()->get_reg_Kunde() != NULL)
			pCmdUI->Enable(FALSE);
		else
			pCmdUI->Enable();
		break;
	
	case ID_EINLAGENVERWALTUNG_NEUEEINLAGE_GIRO:
		if (theApp.GetSteMaBank()->get_reg_Kunde() != NULL)
			pCmdUI->Enable();
		else
			pCmdUI->Enable(FALSE);
		break;
	case ID_EINLAGENVERWALTUNG_NEUEEINLAGE_SPARBUCH:
		if (theApp.GetSteMaBank()->get_reg_Kunde() != NULL)
			pCmdUI->Enable();
		else
			pCmdUI->Enable(FALSE);
		break;
	case ID_EINLAGENVERWALTUNG_NEUEEINLAGE_FESTGELD:
		if (theApp.GetSteMaBank()->get_reg_Kunde() != NULL)
			pCmdUI->Enable();
		else
			pCmdUI->Enable(FALSE);
		break;

	} //end switch
}


void CMainFrame::OnUpdateAuftraege(CCmdUI* pCmdUI)
{
	switch(pCmdUI->m_nID)
	{
	case ID_AUFTRAGSVERWALTUNG_NEU_BERWEISUNG:
		if (theApp.GetSteMaBank()->get_reg_Kunde() != NULL)
			pCmdUI->Enable();
		else
			pCmdUI->Enable(FALSE);
		break;
	
	case ID_AUFTRAGSVERWALTUNG_NEU_EINZAHLUNG:
		if (theApp.GetSteMaBank()->get_reg_Kunde() != NULL)
			pCmdUI->Enable();
		else
			pCmdUI->Enable(FALSE);
		break;

	case ID_AUFTRAGSVERWALTUNG_NEU_AUSZAHLUNG:
		if (theApp.GetSteMaBank()->get_reg_Kunde() != NULL)
			pCmdUI->Enable();
		else
			pCmdUI->Enable(FALSE);
		break;

	} //end switch
}

void CMainFrame::OnUpdateEinlagenverwaltung(CCmdUI* pCmdUI)
{
	switch(pCmdUI->m_nID)
	{
	case ID_EINLAGENVERWALTUNG_NEUEEINLAGE:
		if (theApp.GetSteMaBank()->get_reg_Kunde() != NULL)
			pCmdUI->Enable();
		else
			pCmdUI->Enable(FALSE);
		break;
	
	case ID_EINLAGENVERWALTUNG_LSCHEN:
		if (theApp.GetSteMaBank()->get_reg_Kunde() != NULL)
			pCmdUI->Enable();
		else
			pCmdUI->Enable(FALSE);
		break;
	} //end switch
}

void CMainFrame::OnKundenverwaltungNeuerkunde() 
{
	Kunde* pKunde;
	pKunde=new Kunde;
	CDialogKundeNeu Dlg(pKunde);
	Dlg.DoModal ();
}


//////////////////////////////////////////////////////////////
//CAboutDialog wurde in Klasse CMainfraim verlagert

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialogdaten
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// berladungen fr virtuelle Funktionen, die vom Anwendungs-Assistenten erzeugt wurden
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV-Untersttzung
	//}}AFX_VIRTUAL

// Implementierung
protected:
	//{{AFX_MSG(CAboutDlg)
		// Keine Nachrichten-Handler
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// Keine Nachrichten-Handler
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// Anwendungsbefehl zum Ausfhren des Dialogfelds
void CMainFrame::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}



void CMainFrame::OnKundenverwaltungKundeanmelden() 
{
	if (theApp.GetSteMaBank()->get_reg_Kunde() == NULL)
	{
		CDialogKundeAn Dlg;
		Dlg.DoModal();
	}
	else
	{	
		theApp.GetMainFrame()->GetAktKundeDlg()->CloseWindow();
		m_pAktKundenDlg = NULL;
		theApp.GetSteMaBank()->set_reg_Kunde(NULL);
		AfxMessageBox("Kunde abgemeldet");
	}
}

void CMainFrame::OnKundenverwaltungKundenstamm() 
{
	CDialogKundenAnzeigen Dlg;
	Dlg.DoModal();
}

void CMainFrame::OnKundenverwaltungKundelschen() 
{
	if (theApp.GetSteMaBank()->del_Kunde(theApp.GetSteMaBank()->get_reg_Kunde()))
	{
		OnKundenverwaltungKundeanmelden();
		AfxMessageBox("Kunde erfolgreich gelscht");
	}
	else 
		AfxMessageBox("Kunde nicht gelscht (besitzt noch Einlagen)!");
}

void CMainFrame::showAktKundenDlg()
{
	m_pAktKundenDlg = new CDialogAktKunde();
	m_pAktKundenDlg->Create(IDD_DIALOG_AKT_KUNDE,this);
}

void CMainFrame::OnEinlagenverwaltungNeueeinlageFestgeld() 
{
	CDialogNewFestgeld dlg;
	dlg.DoModal();
	m_pAktKundenDlg->aktualisiereDaten();
}

void CMainFrame::OnEinlagenverwaltungNeueeinlageSparbuch() 
{
	CDialogNewSparbuch dlg;
	dlg.DoModal();
	m_pAktKundenDlg->aktualisiereDaten();
}

void CMainFrame::OnEinlagenverwaltungNeueeinlageGiro() 
{
	CDialogNewGiro dlg;
	dlg.DoModal();
	m_pAktKundenDlg->aktualisiereDaten();
}

void CMainFrame::OnEinlagenverwaltungLschen() 
{
	CDialogEinlageLoeschen dlg;
	dlg.DoModal();
	m_pAktKundenDlg->aktualisiereDaten();
}

void CMainFrame::OnAuftragsverwaltungNeuAuszahlung() 
{
	CDialogAuszahlung dlg;
	dlg.DoModal();
	m_pAktKundenDlg->aktualisiereDaten();
}

void CMainFrame::OnAuftragsverwaltungNeuBerweisung() 
{
	CDialogUeberweisung dlg;
	dlg.DoModal();
	m_pAktKundenDlg->aktualisiereDaten();
}

void CMainFrame::OnAuftragsverwaltungNeuEinzahlung() 
{
	CDialogEinzahlung dlg;
	dlg.DoModal();
	m_pAktKundenDlg->aktualisiereDaten();
}

void CMainFrame::OnKundenverwaltungBearbeiten() 
{
	CDialogKundeNeu Dlg(theApp.GetSteMaBank()->get_reg_Kunde());
	Dlg.DoModal();
	m_pAktKundenDlg->aktualisiereDaten();
}

