//## begin module.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module.cm

//## begin module.cp preserve=no
//## end module.cp

//## Module: Sparbuch; Package specification
//	Headerfile
//## Subsystem: <Top Level>
//	Dateistruktur des Projektes mit Header- ud
//	Quellcodedateien
//	Erzeugte Dateien werden in MS-VC++ 6.0 Project
//	bernommen und dort ausprogrammiert
//	Der zustzlich  erzeugte Code bleibt auch nach
//	Hinzufgen von Komponenten im Modell erhalten!
//## Source file: c:\daten\uni\sofwaretechnik\stemabank\Sparbuch.h


#ifndef Sparbuch_h
#define Sparbuch_h 1

//## begin module.additionalIncludes preserve=no
//## end module.additionalIncludes

//## begin module.includes preserve=yes
//## end module.includes

// Einlage
#include "Einlage.h"
// globals
#include "globals.h"

//## begin module.declarations preserve=no
//## end module.declarations

//## begin module.additionalDeclarations preserve=yes
//## end module.additionalDeclarations


//## Class: Sparbuch
//	Sparbucheinlage, die einen Mindestbetrag besitzen mu
//## Category: Kunden und Einlagenverwaltung
//## Subsystem: <Top Level>
//## Persistence: Transient
//## Cardinality/Multiplicity: n


class Sparbuch : public Einlage  //## Inherits: Generalisierung

{
  //## begin Sparbuch.initialDeclarations preserve=yes
  //## end Sparbuch.initialDeclarations

  public:
    //## Constructors (generated)
      Sparbuch();

      Sparbuch(const Sparbuch &right);

    //## Destructor (generated)
      ~Sparbuch();


    //## Other Operations (specified)
      //## Operation: check%937474106
      //	berladene verfeinerte berprfungsfunktion von Einlage
      BOOL check(float Betrag = 0);

      //## Operation: Serialize%937866643
      //	jede Datenklasse besitzt ihr eigene
      //	Serialisierungsfunktion.
      //	sie dient zur permanenten Speicherung des gesammten
      //	Datenbestandes der Bank.
      //	jede Klasse serialisiert sich praktisch selbst, indem
      //	sie ihre Daten serialisiert.
      void Serialize(CArchive& ar);

    //## Get and Set Operations for Class Attributes (generated)

      //## Attribute: min_Bestand
      //	Membervariable
      //	Setzt den Mindestbestand des Sparbuches fest
      float get_min_Bestand();
      void set_min_Bestand(const float value);

      //## Attribute: min_Einzahlung
      //	Setzt die Mindestbetrag bei einer Einzahlung bzw.
      //	berweisung fest!
      float get_min_Einzahlung();
      void set_min_Einzahlung(const float value);

    // Additional Public Declarations
      //## begin Sparbuch.public preserve=yes
	  	DECLARE_SERIAL(Sparbuch)
      //## end Sparbuch.public


  protected:
    // Additional Protected Declarations
      //## begin Sparbuch.protected preserve=yes
      //## end Sparbuch.protected


  private:
    // Additional Private Declarations
      //## begin Sparbuch.private preserve=yes
      //## end Sparbuch.private


  private:  //## implementation
    // Data Members for Class Attributes

      //## begin Sparbuch::min_Bestand.attr preserve=no  public: float {U} 0
      float min_Bestand;
      //## end Sparbuch::min_Bestand.attr

      //## begin Sparbuch::min_Einzahlung.attr preserve=no  public: float {U} 0
      float min_Einzahlung;
      //## end Sparbuch::min_Einzahlung.attr

    // Additional Implementation Declarations
      //## begin Sparbuch.implementation preserve=yes
      //## end Sparbuch.implementation

};



// Class Sparbuch 

//## Get and Set Operations for Class Attributes (inline)

inline float Sparbuch::get_min_Bestand()
{
  //## begin Sparbuch::get_min_Bestand%.get preserve=no
  return min_Bestand;
  //## end Sparbuch::get_min_Bestand%.get
}

inline void Sparbuch::set_min_Bestand(const float value)
{
  //## begin Sparbuch::set_min_Bestand%.set preserve=no
  min_Bestand = value;
  //## end Sparbuch::set_min_Bestand%.set
}

inline float Sparbuch::get_min_Einzahlung()
{
  //## begin Sparbuch::get_min_Einzahlung%.get preserve=no
  return min_Einzahlung;
  //## end Sparbuch::get_min_Einzahlung%.get
}

inline void Sparbuch::set_min_Einzahlung(const float value)
{
  //## begin Sparbuch::set_min_Einzahlung%.set preserve=no
  min_Einzahlung = value;
  //## end Sparbuch::set_min_Einzahlung%.set
}





#endif


