//## begin module.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module.cm

//## begin module.cp preserve=no
//## end module.cp

//## Module: Transaktion; Package body
//	Quellcodedatei
//## Subsystem: <Top Level>
//	Dateistruktur des Projektes mit Header- ud
//	Quellcodedateien
//	Erzeugte Dateien werden in MS-VC++ 6.0 Project
//	bernommen und dort ausprogrammiert
//	Der zustzlich  erzeugte Code bleibt auch nach
//	Hinzufgen von Komponenten im Modell erhalten!
//## Source file: c:\daten\uni\sofwaretechnik\stemabank\Trnskton.cpp


//## begin module.additionalIncludes preserve=no
//## end module.additionalIncludes

//## begin module.includes preserve=yes
#include "StdAfx.h"
#include "SteMaBank.h"
//## end module.includes

// Transaktion
#include "Trnskton.h"

//## begin module.declarations preserve=no
//## end module.declarations

//## begin module.additionalDeclarations preserve=yes
	IMPLEMENT_SERIAL(Transaktion, CObject, 1)
//## end module.additionalDeclarations


// Class Transaktion 






//## begin Transaktion::LastTransID.attr preserve=no  public: static int {U} 
int Transaktion::LastTransID;
//## end Transaktion::LastTransID.attr




Transaktion::Transaktion()
  //## begin Transaktion::Transaktion%.hasinit preserve=no
      : Status(UNCHECKED), Betrag(0), Betreff("")
  //## end Transaktion::Transaktion%.hasinit
  //## begin Transaktion::Transaktion%.initialization preserve=yes
	
  //## end Transaktion::Transaktion%.initialization
{
  //## begin Transaktion::Transaktion%.body preserve=yes
	LastTransID++;
	Transaktionsnummer.Format("%4.4d",LastTransID);

	Datum = CTime::GetCurrentTime();
  //## end Transaktion::Transaktion%.body
}


Transaktion::~Transaktion()
{
  //## begin Transaktion::~Transaktion%.body preserve=yes
  //## end Transaktion::~Transaktion%.body
}



//## Other Operations (implementation)
BOOL Transaktion::execute(EinlagenID Einlage)
{
  //## begin Transaktion::execute%935483284.body preserve=yes
		Bank* pBank=theApp.GetSteMaBank();
	if ((Einlage!="") && (check(Einlage)))
	{
		switch (pBank->get_EinlagenTyp(Einlage))
		{
		case SPARBUCH:
		{
			Sparbuch* pSparbuch=pBank->identify_Sparbuch(Einlage);
			if (pSparbuch->updateBestand(signedBetrag(Einlage)))
				return TRUE;
			break;
		}
		case GIROKONTO:
		{
			Girokonto* pGirokonto=pBank->identify_Girokonto(Einlage);
			if (pGirokonto->updateBestand(signedBetrag(Einlage)))
				return TRUE;
			break;
		}
		case FESTGELD:
		{
			Festgeld* pFestgeld=pBank->identify_Festgeld(Einlage);
			if (pFestgeld->updateBestand(signedBetrag(Einlage)))
			{
				pFestgeld->set_Status (FALSE);
				return TRUE;
			}
			break;
		}
		} //end switch
	}
	else if (!check(Einlage)) 
		return FALSE;
	else 
		return TRUE;
	return TRUE;
  //## end Transaktion::execute%935483284.body
}

BOOL Transaktion::check(EinlagenID Einlage)
{
  //## begin Transaktion::check%937474108.body preserve=yes
	Bank* pBank=theApp.GetSteMaBank();
	if (Einlage!="")
	{
		switch (pBank->get_EinlagenTyp(Einlage))
		{
		case SPARBUCH:
		{
			Sparbuch* pSparbuch=pBank->identify_Sparbuch(Einlage);
			if (pSparbuch->check(signedBetrag(Einlage))) 
				return TRUE;
			else 
				return FALSE;
			break;
		}
		case GIROKONTO:
		{
			Girokonto* pGirokonto=pBank->identify_Girokonto(Einlage);
			if (pGirokonto->check(signedBetrag(Einlage))) 
				return TRUE;
			else 
				return FALSE;
			break;
		}
		case FESTGELD:
		{
			Festgeld* pFestgeld=pBank->identify_Festgeld(Einlage);
			if (pFestgeld->check(signedBetrag(Einlage))) 
				return TRUE; 
			else 
				return FALSE;
			break;
		}
		} //end switch
	}
	return TRUE;
  //## end Transaktion::check%937474108.body
}

float Transaktion::signedBetrag(EinlagenID Einlage)
{
  //## begin Transaktion::signedBetrag%937474109.body preserve=yes
	if (Einlage==get_QuelleZiel(0)) 
		return -1*Betrag;
	else if (Einlage==get_QuelleZiel(1)) 
		return Betrag;
	else 
		return 0;
  //## end Transaktion::signedBetrag%937474109.body
}

BOOL Transaktion::executeAll()
{
  //## begin Transaktion::executeAll%937474111.body preserve=yes
	if (execute(get_QuelleZiel(0))&& execute(get_QuelleZiel(1)))
	{
		set_Status(SUCCESSFUL);
		return TRUE;
	}
	else
	{
		set_Status(ISFAILED);
		return FALSE;
	}
  //## end Transaktion::executeAll%937474111.body
}

void Transaktion::Serialize(CArchive& ar)
{
  //## begin Transaktion::Serialize%937866645.body preserve=yes
	CObject::Serialize( ar );

    if( ar.IsStoring() )
    {
		ar << Datum;
		ar << Status;
		ar << Betrag;
		ar << Status;
		ar << Betreff;
		ar << Typ;
		ar << Transaktionsnummer;
		ar << QuelleZiel[0];
		ar << QuelleZiel[1];
	}
	else
	{
		ar >> Datum;
		ar >> Status;
		ar >> Betrag;
		ar >> Status;
		ar >> Betreff;
		ar >> Typ;
		ar >> Transaktionsnummer;
		ar >> QuelleZiel[0];
		ar >> QuelleZiel[1];
	}	
  //## end Transaktion::Serialize%937866645.body
}


// Additional Declarations
//## begin Transaktion.declarations preserve=yes
//## end Transaktion.declarations




