//## begin module.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module.cm

//## begin module.cp preserve=no
//## end module.cp

//## Module: Transaktion; Package specification
//	Headerfile
//## Subsystem: <Top Level>
//	Dateistruktur des Projektes mit Header- ud
//	Quellcodedateien
//	Erzeugte Dateien werden in MS-VC++ 6.0 Project
//	bernommen und dort ausprogrammiert
//	Der zustzlich  erzeugte Code bleibt auch nach
//	Hinzufgen von Komponenten im Modell erhalten!
//## Source file: c:\daten\uni\sofwaretechnik\stemabank\Trnskton.h


#ifndef Trnskton_h
#define Trnskton_h 1

//## begin module.additionalIncludes preserve=no
//## end module.additionalIncludes

//## begin module.includes preserve=yes

//## end module.includes

// globals
#include "globals.h"

//## begin module.declarations preserve=no
//## end module.declarations

//## begin module.additionalDeclarations preserve=yes
//## end module.additionalDeclarations


//## Class: Transaktion; Abstract
//	Klasse zur Darstellung der Vorgnge Einzahlung,
//	Auszahlung und berweisung
//	Hier wurde nur eine Klasse fr alle drei Vorgnge
//	gewhlt, weil von gleicher Struktur!
//## Category: Auftragsverwaltung
//## Subsystem: <Top Level>
//## Persistence: Transient
//## Cardinality/Multiplicity: n


class Transaktion : public MFCOBJECT  //## Inherits: SuBklasse von

{
  //## begin Transaktion.initialDeclarations preserve=yes
  //## end Transaktion.initialDeclarations

  public:
    //## Constructors (generated)
      Transaktion();

    //## Destructor (generated)
      ~Transaktion();


    //## Other Operations (specified)
      //## Operation: execute%935483284
      //	Fhrt die notwendigen Operationen, wie berprfung und
      //	Bestandsvernderung, auf die durch die Einlagennummer
      //	bergebene Einlage durch!
      BOOL execute(EinlagenID Einlage = "");

      //## Operation: check%937474108
      //	berprft die bergebene Einlage durch Aufrufen der je
      //	nach Typ eigenen berprfungsfunktion!
      BOOL check(EinlagenID Einlage = "");

      //## Operation: signedBetrag%937474109
      //	Wandelt den positiven Transaktionsbetrag in eine
      //	vorzeichenbehafteten Betrag, je nach Quelle und Ziel, um
      //	und gibt diesen zurck!
      float signedBetrag(EinlagenID Einlage = "");

      //## Operation: executeAll%937474111
      //	Ruft die execute-Operation jeweils fr die Quell und
      //	Zieleinlage auf und behandelt erste Fehler
      BOOL executeAll();

      //## Operation: Serialize%937866645
      //	jede Datenklasse besitzt ihr eigene
      //	Serialisierungsfunktion.
      //	sie dient zur permanenten Speicherung des gesammten
      //	Datenbestandes der Bank.
      //	jede Klasse serialisiert sich praktisch selbst, indem
      //	sie ihre Daten serialisiert.
      void Serialize(CArchive& ar);

    //## Get and Set Operations for Has Relationships (generated)

      //## Documentation Transaktion::Transaktionsnummer.has
      //	jede Transaktion besitzt eine eigene
      //	Identifikationsnummer
      TransaktionsID get_Transaktionsnummer();

      //## Documentation Transaktion::QuelleZiel.has
      //	jeder Transaktion ist eine Queleinlagennumer und
      //	Zieleinlagennummer zugeordnet. Bei einer Einzahlung ist
      //	Quelle leer bzw. bei einer Auszahlung ist das Ziel leer,
      //	bei einer berweisung sind Quelle und Ziel belegt!
      EinlagenID get_QuelleZiel(const int index);
      void set_QuelleZiel(const int index, const EinlagenID value);

    //## Get and Set Operations for Class Attributes (generated)

      //## Attribute: Datum
      //	enthlt den Zeitpunkt der Erstellung der Transaktion
      const CTime get_Datum() const;

      //## Attribute: Status
      //	zeigt den Status der Transaktion (BYTE) an:
      //	UNCHECKED - Voreinstellung
      //	CHECKED
      //	SUCCESSFUL
      //	ISFAILED
      const BYTE get_Status() const;
      void set_Status(const BYTE value);

      //## Attribute: Betrag
      //	enthlt den Betrag ber den die Transaktion lautet
      float get_Betrag();
      void set_Betrag(const float value);

      //## Attribute: LastTransID
      //	Klassenvariable zur Erstellung einer eindeutigen Nummer,
      //	wird im Konstruktor hochgezhlt und in Klasse
      //	Transaktionsnummer (CString) umgewandelt!
      static int get_LastTransID();

      //## Attribute: Betreff
      //	jede Transaktion hat eien Betreff, um den Grund der
      //	Transaktion spter nachvollziehen knnen!
      CString get_Betreff();
      void set_Betreff(const CString value);

      //## Attribute: Typ
      //	Typ der Transaktion (BYTE):
      //	EINZAHLUNG
      //	AUSZAHLUNG
      //	UEBERWEISUNG
      const BYTE get_Typ() const;
      void set_Typ(const BYTE value);

    // Additional Public Declarations
      //## begin Transaktion.public preserve=yes
	  	DECLARE_SERIAL(Transaktion)
      //## end Transaktion.public


  protected:
    // Additional Protected Declarations
      //## begin Transaktion.protected preserve=yes
      //## end Transaktion.protected


  private:
    // Additional Private Declarations
      //## begin Transaktion.private preserve=yes
      //## end Transaktion.private


  private:  //## implementation
    // Data Members for Has Relationships

      //## begin Transaktion::Transaktionsnummer.has preserve=no  public: TransaktionsID {1 -> 1VO}
      TransaktionsID Transaktionsnummer;
      //## end Transaktion::Transaktionsnummer.has

      //## begin Transaktion::QuelleZiel.has preserve=no  public: EinlagenID {1 -> 2VO}
      EinlagenID QuelleZiel[2];
      //## end Transaktion::QuelleZiel.has

    // Data Members for Class Attributes

      //## begin Transaktion::Datum.attr preserve=no  public: CTime {U} 
      CTime Datum;
      //## end Transaktion::Datum.attr

      //## begin Transaktion::Status.attr preserve=no  public: BYTE {U} UNCHECKED
      BYTE Status;
      //## end Transaktion::Status.attr

      //## begin Transaktion::Betrag.attr preserve=no  public: float {U} 0
      float Betrag;
      //## end Transaktion::Betrag.attr

      //## begin Transaktion::LastTransID.attr preserve=no  public: static int {U} 
      static int LastTransID;
      //## end Transaktion::LastTransID.attr

      //## begin Transaktion::Betreff.attr preserve=no  public: CString {U} ""
      CString Betreff;
      //## end Transaktion::Betreff.attr

      //## begin Transaktion::Typ.attr preserve=no  public: BYTE {U} 
      BYTE Typ;
      //## end Transaktion::Typ.attr

    // Data Members for Associations

      //## Association: durchfuehren%37C29D12012C
      //## Role: Transaktion::Auftraggeber
      //## begin Transaktion::Auftraggeber.role preserve=no  public: Bank {0..n -> 1..1RH}
      //## end Transaktion::Auftraggeber.role

    // Additional Implementation Declarations
      //## begin Transaktion.implementation preserve=yes
      //## end Transaktion.implementation

};



// Class Transaktion 

//## Get and Set Operations for Has Relationships (inline)

inline TransaktionsID Transaktion::get_Transaktionsnummer()
{
  //## begin Transaktion::get_Transaktionsnummer%.get preserve=no
  return Transaktionsnummer;
  //## end Transaktion::get_Transaktionsnummer%.get
}

inline EinlagenID Transaktion::get_QuelleZiel(const int index)
{
  //## begin Transaktion::get_QuelleZiel%.get preserve=no
  return QuelleZiel[index];
  //## end Transaktion::get_QuelleZiel%.get
}

inline void Transaktion::set_QuelleZiel(const int index, const EinlagenID value)
{
  //## begin Transaktion::set_QuelleZiel%.set preserve=no
  QuelleZiel[index] = value;
  //## end Transaktion::set_QuelleZiel%.set
}

//## Get and Set Operations for Class Attributes (inline)

inline const CTime Transaktion::get_Datum() const
{
  //## begin Transaktion::get_Datum%.get preserve=no
  return Datum;
  //## end Transaktion::get_Datum%.get
}

inline const BYTE Transaktion::get_Status() const
{
  //## begin Transaktion::get_Status%.get preserve=no
  return Status;
  //## end Transaktion::get_Status%.get
}

inline void Transaktion::set_Status(const BYTE value)
{
  //## begin Transaktion::set_Status%.set preserve=no
  Status = value;
  //## end Transaktion::set_Status%.set
}

inline float Transaktion::get_Betrag()
{
  //## begin Transaktion::get_Betrag%.get preserve=no
  return Betrag;
  //## end Transaktion::get_Betrag%.get
}

inline void Transaktion::set_Betrag(const float value)
{
  //## begin Transaktion::set_Betrag%.set preserve=no
  Betrag = value;
  //## end Transaktion::set_Betrag%.set
}

inline int Transaktion::get_LastTransID()
{
  //## begin Transaktion::get_LastTransID%.get preserve=no
  return LastTransID;
  //## end Transaktion::get_LastTransID%.get
}

inline CString Transaktion::get_Betreff()
{
  //## begin Transaktion::get_Betreff%.get preserve=no
  return Betreff;
  //## end Transaktion::get_Betreff%.get
}

inline void Transaktion::set_Betreff(const CString value)
{
  //## begin Transaktion::set_Betreff%.set preserve=no
  Betreff = value;
  //## end Transaktion::set_Betreff%.set
}

inline const BYTE Transaktion::get_Typ() const
{
  //## begin Transaktion::get_Typ%.get preserve=no
  return Typ;
  //## end Transaktion::get_Typ%.get
}

inline void Transaktion::set_Typ(const BYTE value)
{
  //## begin Transaktion::set_Typ%.set preserve=no
  Typ = value;
  //## end Transaktion::set_Typ%.set
}





#endif


