//## begin module.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module.cm

//## begin module.cp preserve=no
//## end module.cp

//## Module: globals; Package specification
//	Headerfile zur globalen Typdefinition TransaktionID
//	KundenID
//	EinlagenID und
//	#define BYTE Deklarationen:
//	SPARBUCH
//	FESTGELD
//	GIROKONTO
//	EINZAHLUNG
//	AUSZAHLUNG
//	UEBERWEISUNG
//	CHECKED
//	UNCHECKED
//	SUCCESSFUL
//	ISFAILED
//## Subsystem: <Top Level>
//	Dateistruktur des Projektes mit Header- ud
//	Quellcodedateien
//	Erzeugte Dateien werden in MS-VC++ 6.0 Project
//	bernommen und dort ausprogrammiert
//	Der zustzlich  erzeugte Code bleibt auch nach
//	Hinzufgen von Komponenten im Modell erhalten!
//## Source file: c:\daten\uni\sofwaretechnik\stemabank\globals.h


#ifndef globals_h
#define globals_h 1

//## begin module.additionalIncludes preserve=no
//## end module.additionalIncludes

//## begin module.includes preserve=yes
//## end module.includes


//## begin module.declarations preserve=no
// globale Headerfiles werden hier eingeladen
#include "stdlib.h"
#include "StdAfx.h"
#include "math.h"
//globale Typdefinitionen
#define SPARBUCH 1
#define GIROKONTO 2
#define FESTGELD 3
#define EINZAHLUNG 4
#define UEBERWEISUNG 5
#define AUSZAHLUNG 6
#define UNCHECKED 7
#define CHECKED 8
#define SUCCESSFUL 9
#define ISFAILED 10
//## end module.declarations

//## begin module.additionalDeclarations preserve=yes
// globale Headerfiles werden hier eingeladen


//## end module.additionalDeclarations


//## Class: KundenID
//	jeder Kunde wird durch eine 4-stellige ID-Nummer
//	identifiziert. Die Klasse KundenID ist vom Typ CString
//	und wird nicht implementiert!
//## Category: Kunden und Einlagenverwaltung
//## Subsystem: <Top Level>
//## Persistence: Transient
//## Cardinality/Multiplicity: n


typedef CString KundenID;


//## Class: EinlagenID
//	jede Geldeilage wird durch eine 8 stellige ID-Nummer
//	eindeutig zugeordnet
//	Sie setzt sich aus der vierstelligen Kundennummer, einem
//	einstelligen Code fr die Art der Einlage und der
//	dreistelligen Einlagennummer selbst zusammen!
//	Die Klasse EinlagenID ist vom Typ CString (Siehe cg) und
//	wird nicht implementiert!
//## Category: Kunden und Einlagenverwaltung
//## Subsystem: <Top Level>
//## Persistence: Transient
//## Cardinality/Multiplicity: n


typedef CString EinlagenID;


//## Class: TransaktionsID
//	vierstellige Transaktionsnummer,
//	jeder Transaktion ist eine solche Nummer zugeordnet
//## Category: Auftragsverwaltung
//## Subsystem: <Top Level>
//## Persistence: Transient
//## Cardinality/Multiplicity: n


typedef CString TransaktionsID;


//## Class: MFCOBJECT
//	Typdefinition als CObjekt zur Einbindung der
//	MFC-Routinen und Archievierungsmethoden (Speicherung in
//	eine Datei)
//## Category: MFC-Anbindung
//## Subsystem: <Top Level>
//## Persistence: Transient
//## Cardinality/Multiplicity: n


typedef CObject MFCOBJECT;


// Class KundenID 





// Class EinlagenID 





// Class TransaktionsID 





// Class MFCOBJECT 





#endif


